Require Import ssreflect.
Require Import ssrfun.
Require Import ssrbool.

Require Import Utf8.
Require Import List.
Require Import Setoid.
Require Import Morphisms.

Require Import LibTactics.
Require Import DomType.
Require Import DomBasic.
Require Import DomUtil.
Require Import DomBridge.
Require Import DomSet.
Require Import DomMap.
Require Import DomZ.
Require Import DomItv.
Require Import DomAbsValue.

Require Import Syntax.

Require Import Containers.SetProperties.
Require Import Containers.MapInterface.

Set Implicit Arguments.


Section Accs.
  Structure accT := Acc {
    callfroms : Map![fidT, Set![fidT * bidT]];
    callfroms_star : Map![fidT, Set![fidT]];
    acclocs : Map![fidT, Set![locT]]
  }.

  Definition not_recursive (acc:accT) (fid:fidT) : bool :=
    ~~ (fid !\in ((callfroms_star acc)[fid]! : Set![fidT])).

  Definition is_strong (acc:accT) (loc:locT) : bool :=
    match loc with
      | (inl (inl _), _) => false
      | (inl (inr _), _) => true
      | (inr (fid, _), _) => not_recursive acc fid
    end.
End Accs.
