Require Import ssreflect.
Require Import ssrfun.
Require Import ssrbool.

Require Import Utf8.
Require Import List.
Require Import Setoid.
Require Import Morphisms.

Require Import LibTactics.
Require Import DomType.
Require Import DomBasic.
Require Import DomUtil.
Require Import DomBridge.
Require Import DomSet.
Require Import DomMap.
Require Import DomZ.
Require Import DomItv.
Require Import DomPidx.

Require Import Syntax.

Require Import Containers.SetProperties.
Require Import Containers.MapInterface.

Set Implicit Arguments.

Definition pidxT := (fidT * bidT * bool)%type.

Global Instance pidxT_setoid : setoid pidxT := _.
Global Instance pidxT_usual_setoid : @usual_setoid pidxT _ := _.
Global Instance pidxT_setoidDec : @setoidDec pidxT _ := _.
Global Instance pidxT_poset : @poset pidxT _ := _.
Global Instance pidxT_posetDec : @posetDec pidxT _ _ _ := _. 

Global Program Instance pidxT_pidx : @pidx pidxT _ := {
  piinitial prog :=
  if (pfuncs prog)[pentry prog] is Some func
  then Some (pentry prog, fentry func, false)
  else None;
  pifid := nosimpl (fun pidx => pidx.1.1);
  pibid := nosimpl (fun pidx => pidx.1.2);
  piepilogue := nosimpl (fun pidx => pidx.2)
}.
Next Obligation.
  by move=> [[x x'] x''] [[y y'] y''] [[? ?] ?].
Qed.
Next Obligation.
  by move=> [[x x'] x''] [[y y'] y''] [[? ?] ?].
Qed.
Next Obligation.
  by move=> [[x x'] x''] [[y y'] y''] [[? ?] ?].
Qed.
