open Datatypes
open DomBasic
open DomBridge
open DomItv
open DomMap
open DomSet
open DomType
open MapAVLInstance
open MapInterface
open SetAVLInstance
open SetInterface

type locT = ((allocT, idT) sum, fidT * idT) sum * idT list

val locT_setoid : locT setoid

val locT_setoidDec : locT setoidDec

val locT_poset : locT poset

val locT_posetDec : locT posetDec

val lheap : allocT -> idT list -> locT

val lglobal : idT -> idT list -> locT

val llocal : fidT -> idT -> idT list -> locT

val var_loc : fidT -> varT -> idT list -> locT

type locsT = locT set withtop

val filter_fid : fidT -> locT powerset

type osT = itvT * itvT

val osT_poset : osT poset

val osT_hasBot : osT hasBot

val osT_hasJoin : osT hasJoin

type ossT = osT * itvT

val ossT_poset : ossT poset

val ossT_hasBot : ossT hasBot

val ossT_hasJoin : ossT hasJoin

type arrvT' = (allocT, ossT) dict

val arrvT'_poset : arrvT' poset

val arrvT'_hasBot : arrvT' hasBot

val arrvT'_hasJoin : arrvT' hasJoin

type arrvT = arrvT' withtop

val arrvT_poset : arrvT poset

val arrvT_hasBot : arrvT hasBot

val arrvT_hasJoin : arrvT hasJoin

val locs_from_arrvT : arrvT -> locsT

type valueT = (itvT * locsT) * arrvT

val itv_of : valueT -> itvT

val locs_of : valueT -> locsT

val arrv_of : valueT -> arrvT

val itv_to_valueT : itvT -> valueT

val locs_to_valueT : locsT -> valueT

val arrv_to_valueT : arrvT -> valueT

val valueT_setoid : valueT setoid

val valueT_poset : valueT poset

val valueT_hasBot : valueT hasBot

val valueT_hasTop : valueT hasTop

val valueT_hasJoin : valueT hasJoin

val arrv_op_add : arrvT -> itvT -> arrvT

val arrv_op_sub : arrvT -> itvT -> arrvT

val vconst : int -> valueT

val vop1 : op1 -> valueT -> valueT

val vop2 : op2 -> valueT -> valueT -> valueT

