open Datatypes
open DomAbsValue
open DomBasic
open DomMap
open DomSet
open DomType
open MapInterface
open SetInterface

type accT = { callfroms : (fidT, (fidT * bidT) set) dict;
              callfroms_star : (fidT, fidT set) dict;
              acclocs : (fidT, locT set) dict }

(** val callfroms : accT -> (fidT, (fidT * bidT) set) dict **)

let callfroms x = x.callfroms

(** val callfroms_star : accT -> (fidT, fidT set) dict **)

let callfroms_star x = x.callfroms_star

(** val acclocs : accT -> (fidT, locT set) dict **)

let acclocs x = x.acclocs

(** val not_recursive : accT -> fidT -> bool **)

let not_recursive acc fid =
  negb
    ((set_setlike positive_setoid positive_poset positive_setoidDec
       positive_posetDec).smem fid
      ((map_maplike positive_setoid positive_poset positive_setoidDec
         positive_posetDec
         (set_setoid positive_setoid positive_poset positive_setoidDec
           positive_posetDec)
         (set_poset positive_setoid positive_poset positive_setoidDec
           positive_posetDec)
         (set_hasBot positive_setoid positive_poset positive_setoidDec
           positive_posetDec)).mlookup fid acc.callfroms_star))

(** val is_strong : accT -> locT -> bool **)

let is_strong acc = function
| (s, l) ->
  (match s with
   | Coq_inl s0 ->
     (match s0 with
      | Coq_inl a -> false
      | Coq_inr i -> true)
   | Coq_inr p -> let (fid, i) = p in not_recursive acc fid)

