open BinPos
open Datatypes
open DomType
open Ssrbool

type ('a, 'b) morphism = ('a -> 'b)

type 'a powerset = ('a, bool) morphism

val powerset_setlike :
  'a1 setoid -> 'a1 setoidDec -> ('a1, 'a1 powerset) setlike

val powerset_neg : 'a1 setoid -> 'a1 powerset -> 'a1 powerset

type ('k, 'e, 'm) restricting_maplike =
  'k powerset -> 'm -> 'm
  (* singleton inductive, whose constructor was RestrictingMaplike *)

val mrestrict :
  'a1 setoid -> 'a1 setoidDec -> 'a2 setoid -> 'a2 poset -> 'a3 setoid -> 'a3
  poset -> 'a3 hasBot -> ('a1, 'a2, 'a3) maplike -> ('a1, 'a2, 'a3)
  restricting_maplike -> 'a1 powerset -> 'a3 -> 'a3

val option_setoid : 'a1 setoid -> 'a1 option setoid

val option_poset : 'a1 setoid -> 'a1 poset -> 'a1 option poset

val option_hasBot : 'a1 setoid -> 'a1 poset -> 'a1 option hasBot

val option_hasTop :
  'a1 setoid -> 'a1 poset -> 'a1 hasTop -> 'a1 option hasTop

val option_join :
  'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 option -> 'a1 option -> 'a1
  option

val option_hasJoin :
  'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 option hasJoin

val option_eqb :
  'a1 setoid -> 'a1 setoidDec -> 'a1 option -> 'a1 option -> bool

val option_setoidDec_obligation_1 :
  'a1 setoid -> 'a1 setoidDec -> 'a1 option -> 'a1 option -> reflect

val option_setoidDec : 'a1 setoid -> 'a1 setoidDec -> 'a1 option setoidDec

val option_leb :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 option ->
  'a1 option -> bool

val option_posetDec_obligation_1 :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 option ->
  'a1 option -> reflect

val option_posetDec :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 option
  posetDec

type 'a withtop =
| Elt of 'a
| Top

val withtop_setoid : 'a1 setoid -> 'a1 withtop setoid

val withtop_poset : 'a1 setoid -> 'a1 poset -> 'a1 withtop poset

val withtop_hasBot :
  'a1 setoid -> 'a1 poset -> 'a1 hasBot -> 'a1 withtop hasBot

val withtop_hasTop : 'a1 setoid -> 'a1 poset -> 'a1 withtop hasTop

val withtop_join :
  'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 withtop -> 'a1 withtop -> 'a1
  withtop

val withtop_hasJoin :
  'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 withtop hasJoin

val withtop_eqb :
  'a1 setoid -> 'a1 setoidDec -> 'a1 withtop -> 'a1 withtop -> bool

val withtop_setoidDec_obligation_1 :
  'a1 setoid -> 'a1 setoidDec -> 'a1 withtop -> 'a1 withtop -> reflect

val withtop_setoidDec : 'a1 setoid -> 'a1 setoidDec -> 'a1 withtop setoidDec

val withtop_leb :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 withtop ->
  'a1 withtop -> bool

val withtop_posetDec_obligation_1 :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 withtop ->
  'a1 withtop -> reflect

val withtop_posetDec :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 withtop
  posetDec

val withtop_maplike :
  'a1 setoid -> 'a1 poset -> 'a2 setoid -> 'a2 setoidDec -> 'a3 setoid -> 'a3
  poset -> 'a3 hasTop -> ('a2, 'a3, 'a1) maplike -> ('a2, 'a3, 'a1 withtop)
  maplike

val withtop_restricting_maplike :
  'a1 setoid -> 'a1 poset -> 'a2 setoid -> 'a2 setoidDec -> 'a3 setoid -> 'a3
  poset -> 'a3 hasTop -> 'a1 hasBot -> ('a2, 'a3, 'a1) maplike -> ('a2, 'a3,
  'a1) restricting_maplike -> ('a2, 'a3, 'a1 withtop) restricting_maplike

val pair_setoid : 'a1 setoid -> 'a2 setoid -> ('a1 * 'a2) setoid

val pair_poset :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> ('a1 * 'a2) poset

val pair_eqb :
  'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1 * 'a2)
  -> ('a1 * 'a2) -> bool

val pair_setoidDec_obligation_1 :
  'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1 * 'a2)
  -> ('a1 * 'a2) -> reflect

val pair_setoidDec :
  'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1 * 'a2)
  setoidDec

val pair_leb :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec -> 'a2
  setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) -> ('a1 * 'a2) ->
  bool

val pair_posetDec_obligation_1 :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec -> 'a2
  setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) -> ('a1 * 'a2) ->
  reflect

val pair_posetDec :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec -> 'a2
  setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) posetDec

val pair_poset_pointwise :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> ('a1 * 'a2) poset

val pair_hasBot_pointwise :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 hasBot -> 'a2
  hasBot -> ('a1 * 'a2) hasBot

val pair_hasTop_pointwise :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 hasTop -> 'a2
  hasTop -> ('a1 * 'a2) hasTop

val pair_hasJoin_pointwise :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 hasJoin -> 'a2
  hasJoin -> ('a1 * 'a2) hasJoin

val pair_posetDec_pointwise_obligation_1 :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec -> 'a2
  setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) -> ('a1 * 'a2) ->
  reflect

val pair_posetDec_pointwise :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec -> 'a2
  setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) posetDec

val sum_setoid : 'a1 setoid -> 'a2 setoid -> ('a1, 'a2) sum setoid

val sum_poset :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> ('a1, 'a2) sum poset

val sum_eqb :
  'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1, 'a2)
  sum -> ('a1, 'a2) sum -> bool

val sum_setoidDec_obligation_1 :
  'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1, 'a2)
  sum -> ('a1, 'a2) sum -> reflect

val sum_setoidDec :
  'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1, 'a2)
  sum setoidDec

val sum_leb :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec -> 'a2
  setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1, 'a2) sum -> ('a1, 'a2)
  sum -> bool

val sum_posetDec_obligation_1 :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec -> 'a2
  setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1, 'a2) sum -> ('a1, 'a2)
  sum -> reflect

val sum_posetDec :
  'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec -> 'a2
  setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1, 'a2) sum posetDec

val list_setoid : 'a1 setoid -> 'a1 list setoid

val list_poset : 'a1 setoid -> 'a1 poset -> 'a1 list poset

val list_eqb : 'a1 setoid -> 'a1 setoidDec -> 'a1 list -> 'a1 list -> bool

val list_setoidDec_obligation_1 :
  'a1 setoid -> 'a1 setoidDec -> 'a1 list -> 'a1 list -> reflect

val list_setoidDec : 'a1 setoid -> 'a1 setoidDec -> 'a1 list setoidDec

val list_leb :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 list -> 'a1
  list -> bool

val list_posetDec_obligation_1 :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 list -> 'a1
  list -> reflect

val list_posetDec :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 list
  posetDec

val positive_setoid : int setoid

val positive_poset : int poset

val positive_setoidDec_obligation_1 : int -> int -> reflect

val positive_setoidDec : int setoidDec

val positive_posetDec_obligation_1 : int -> int -> reflect

val positive_posetDec : int posetDec

type idT = int

type allocT = idT

type bidT = idT

type fidT = idT

type varT = (idT, idT) sum

val varT_setoid : varT setoid

val varT_setoidDec : varT setoidDec

val varT_poset : varT poset

val varT_posetDec : varT posetDec

type op1 =
| Coq_op_not
| Coq_op_bnot

type op2 =
| Coq_op_add
| Coq_op_sub
| Coq_op_mul
| Coq_op_div
| Coq_op_mod
| Coq_op_lt
| Coq_op_le
| Coq_op_gt
| Coq_op_ge
| Coq_op_eq
| Coq_op_neq
| Coq_op_and
| Coq_op_or
| Coq_op_band
| Coq_op_bor
| Coq_op_bxor
| Coq_op_lshift
| Coq_op_rshift

