open BinInt
open Datatypes
open DomType
open DomUtil
open DomZ
open ZArith_dec
open Ssrbool

type itvT' =
| Coq_itv'_top
| Coq_itv'_inf_z of int
| Coq_itv'_z_inf of int
| Coq_itv'_z_z of int * int

val itv'_btop : itvT'

val itvT'_setoid : itvT' setoid

val itvT'_poset : itvT' poset

val itvT'_hasTop : itvT' hasTop

val itvT'_hasJoin : itvT' hasJoin

val itvT'_setoidDec_obligation_1 : itvT' -> itvT' -> reflect

val itvT'_setoidDec : itvT' setoidDec

val itvT'_posetDec_obligation_1 : itvT' -> itvT' -> reflect

val itvT'_posetDec : itvT' posetDec

val op_add' : itvT' -> itvT' -> itvT'

val op_sub' : itvT' -> itvT' -> itvT'

val op_mul' : itvT' -> itvT' -> itvT'

val op_div' : itvT' -> itvT' -> itvT'

val op_mod' : itvT' -> itvT' -> itvT'

val op_lt' : itvT' -> itvT' -> itvT'

val op_le' : itvT' -> itvT' -> itvT'

val op_gt' : itvT' -> itvT' -> itvT'

val op_ge' : itvT' -> itvT' -> itvT'

val op_eq' : itvT' -> itvT' -> itvT'

val op_not' : itvT' -> itvT'

val op_neq' : itvT' -> itvT' -> itvT'

val op_and' : itvT' -> itvT' -> itvT'

val op_or' : itvT' -> itvT' -> itvT'

val op_band' : itvT' -> itvT' -> itvT'

val op_bor' : itvT' -> itvT' -> itvT'

val op_bxor' : itvT' -> itvT' -> itvT'

val op_lshift' : itvT' -> itvT' -> itvT'

val op_rshift' : itvT' -> itvT' -> itvT'

val op_bnot' : itvT' -> itvT'

type itvT = itvT' option

val op_add : itvT -> itvT -> itvT

val op_sub : itvT -> itvT -> itvT

val op_mul : itvT -> itvT -> itvT

val op_div : itvT -> itvT -> itvT

val op_mod : itvT -> itvT -> itvT

val op_lt : itvT -> itvT -> itvT

val op_le : itvT -> itvT -> itvT

val op_gt : itvT -> itvT -> itvT

val op_ge : itvT -> itvT -> itvT

val op_eq : itvT -> itvT -> itvT

val op_neq : itvT -> itvT -> itvT

val op_and : itvT -> itvT -> itvT

val op_or : itvT -> itvT -> itvT

val op_band : itvT -> itvT -> itvT

val op_bor : itvT -> itvT -> itvT

val op_bxor : itvT -> itvT -> itvT

val op_lshift : itvT -> itvT -> itvT

val op_rshift : itvT -> itvT -> itvT

val op_not : itvT -> itvT

val op_bnot : itvT -> itvT

