open DomBasic
open DomBridge
open DomType
open MapAVLInstance
open MapInterface
open Maps
open Ssrbool

(** val map_forall :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a1 -> 'a2
    -> bool) -> ('a1, 'a2) dict -> bool **)

let map_forall setoidKey posetKey setoidDecKey posetDecKey test m =
  fold (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
    (coq_MapAVL_FMap
      (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
    (fun k v acc -> (&&) acc (test k v)) m true

(** val map_elt_compare :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a2 option
    -> 'a2 option -> bool) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool **)

let map_elt_compare setoidKey posetKey setoidDecKey posetDecKey test x y =
  is_empty (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
    (coq_MapAVL_FMap
      (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
    (map2 (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
      (coq_MapAVL_FMap
        (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
      (fun x0 y0 -> if test x0 y0 then None else Some ()) x y)

(** val map_elt_compareP :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a2 option
    -> 'a2 option -> bool) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> reflect **)

let map_elt_compareP setoidKey posetKey setoidDecKey posetDecKey test x y =
  let _evar_0_ =
    idP
      (is_empty
        (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
        (coq_MapAVL_FMap
          (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
        (map2 (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
          (coq_MapAVL_FMap
            (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
          (fun x0 y0 -> if test x0 y0 then None else Some ()) x y))
  in
  equivP
    (is_empty (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
      (coq_MapAVL_FMap
        (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
      (map2 (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
        (coq_MapAVL_FMap
          (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
        (fun x0 y0 -> if test x0 y0 then None else Some ()) x y)) _evar_0_

(** val coerce :
    'a1 setoid -> 'a1 poset -> 'a1 hasBot -> 'a1 option -> 'a1 **)

let coerce h0 h1 hasBotElt = function
| Some e -> e
| None -> bot h0 h1 hasBotElt

(** val map_setoid :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> ('a1, 'a2) dict setoid **)

let map_setoid setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt =
  Setoid

(** val map_poset :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> ('a1, 'a2) dict poset **)

let map_poset setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt =
  Poset

(** val map_maplike :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> ('a1, 'a2, ('a1, 'a2) dict) maplike **)

let map_maplike setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt =
  { mlookup = (fun key m ->
    coerce h0 h1 hasBotElt
      (find (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
        (coq_MapAVL_FMap
          (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
        key m)); madd =
    (add (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
      (coq_MapAVL_FMap
        (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)));
    mremove =
    (remove (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
      (coq_MapAVL_FMap
        (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))) }

(** val map_hasBot :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> ('a1, 'a2) dict hasBot **)

let map_hasBot setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt =
  empty (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
    (coq_MapAVL_FMap
      (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))

(** val map_setoidDec_obligation_2 :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> 'a2 setoidDec -> ('a1, 'a2) dict -> ('a1, 'a2)
    dict -> reflect **)

let map_setoidDec_obligation_2 setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt setoidDecElt x y =
  let _evar_0_ =
    map_elt_compareP setoidKey posetKey setoidDecKey posetDecKey
      (fun x0 y0 ->
      eqb h0 setoidDecElt (coerce h0 h1 hasBotElt x0)
        (coerce h0 h1 hasBotElt y0)) x y
  in
  equivP
    (map_elt_compare setoidKey posetKey setoidDecKey posetDecKey
      (fun x0 y0 ->
      eqb h0 setoidDecElt (coerce h0 h1 hasBotElt x0)
        (coerce h0 h1 hasBotElt y0)) x y) _evar_0_

(** val map_setoidDec :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> 'a2 setoidDec -> ('a1, 'a2) dict setoidDec **)

let map_setoidDec setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt setoidDecElt =
  { eqb_ =
    (map_elt_compare setoidKey posetKey setoidDecKey posetDecKey (fun x y ->
      eqb h0 setoidDecElt (coerce h0 h1 hasBotElt x)
        (coerce h0 h1 hasBotElt y))); eqbP_ =
    (map_setoidDec_obligation_2 setoidKey posetKey setoidDecKey posetDecKey
      h0 h1 hasBotElt setoidDecElt) }

(** val map_posetDec_obligation_2 :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> 'a2 setoidDec -> 'a2 posetDec -> ('a1, 'a2)
    dict -> ('a1, 'a2) dict -> reflect **)

let map_posetDec_obligation_2 setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt setoidDecElt posetDecElt x y =
  let _evar_0_ =
    map_elt_compareP setoidKey posetKey setoidDecKey posetDecKey
      (fun x0 y0 ->
      leb h0 h1 setoidDecElt posetDecElt (coerce h0 h1 hasBotElt x0)
        (coerce h0 h1 hasBotElt y0)) x y
  in
  equivP
    (map_elt_compare setoidKey posetKey setoidDecKey posetDecKey
      (fun x0 y0 ->
      leb h0 h1 setoidDecElt posetDecElt (coerce h0 h1 hasBotElt x0)
        (coerce h0 h1 hasBotElt y0)) x y) _evar_0_

(** val map_posetDec :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> 'a2 setoidDec -> 'a2 posetDec -> ('a1, 'a2)
    dict posetDec **)

let map_posetDec setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt setoidDecElt posetDecElt =
  { leb_ =
    (map_elt_compare setoidKey posetKey setoidDecKey posetDecKey (fun x y ->
      leb h0 h1 setoidDecElt posetDecElt (coerce h0 h1 hasBotElt x)
        (coerce h0 h1 hasBotElt y))); lebP_ =
    (map_posetDec_obligation_2 setoidKey posetKey setoidDecKey posetDecKey h0
      h1 hasBotElt setoidDecElt posetDecElt) }

(** val map_hasJoin :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> 'a2 hasJoin -> ('a1, 'a2) dict hasJoin **)

let map_hasJoin setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt hasJoinElt x y =
  map2 (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
    (coq_MapAVL_FMap
      (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
    (fun x0 y0 ->
    match x0 with
    | Some x' ->
      (match y0 with
       | Some y' -> Some (join h0 h1 hasJoinElt x' y')
       | None -> x0)
    | None -> y0) x y

(** val map_mrestrict :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 powerset
    -> ('a1, 'a2) dict -> ('a1, 'a2) dict **)

let map_mrestrict setoidKey posetKey setoidDecKey posetDecKey s m =
  MF.filter (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey)
    (coq_MapAVL_FMap
      (order_OrderedType setoidKey posetKey setoidDecKey posetDecKey))
    (fun key x -> (powerset_setlike setoidKey setoidDecKey).smem key s) m

(** val map_restricting_maplike :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
    'a2 poset -> 'a2 hasBot -> ('a1, 'a2, ('a1, 'a2) dict)
    restricting_maplike **)

let map_restricting_maplike setoidKey posetKey setoidDecKey posetDecKey h0 h1 hasBotElt =
  map_mrestrict setoidKey posetKey setoidDecKey posetDecKey

