open DomBasic
open DomBridge
open DomType
open SetAVLInstance
open SetInterface
open Ssrbool

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val set_setoid :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set
    setoid **)

let set_setoid setoidA posetA setoidDecA posetDecA =
  Setoid

(** val set_setlike :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a1, 'a1
    set) setlike **)

let set_setlike setoidA posetA setoidDecA posetDecA =
  { sempty =
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).empty;
    ssingleton =
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).singleton;
    smem =
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).mem;
    sadd =
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).add;
    sremove =
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).remove }

(** val set_forall :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a1 -> bool)
    -> 'a1 set -> bool **)

let set_forall setoidA posetA setoidDecA posetDecA =
  (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).for_all

(** val map :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a1, 'a1)
    morphism -> 'a1 set -> 'a1 set **)

let map setoidA posetA setoidDecA posetDecA f m =
  fold (order_OrderedType setoidA posetA setoidDecA posetDecA)
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA))
    (fun a m0 ->
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).add
      (f a) m0) m
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).empty

(** val set_poset :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set poset **)

let set_poset setoidA posetA setoidDecA posetDecA =
  Poset

(** val set_hasBot :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set
    hasBot **)

let set_hasBot setoidA posetA setoidDecA posetDecA =
  (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).empty

(** val set_hasJoin :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set
    hasJoin **)

let set_hasJoin setoidA posetA setoidDecA posetDecA x y =
  (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).union
    x y

(** val set_setoidDec_obligation_1 :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set ->
    'a1 set -> reflect **)

let set_setoidDec_obligation_1 setoidA posetA setoidDecA posetDecA x y =
  let _evar_0_ = fun _ -> ReflectT in
  let _evar_0_0 = fun _ -> ReflectF in
  if (coq_SetAVL_FSet
       (order_OrderedType setoidA posetA setoidDecA posetDecA)).equal x y
  then _evar_0_ __
  else _evar_0_0 __

(** val set_setoidDec :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set
    setoidDec **)

let set_setoidDec setoidA posetA setoidDecA posetDecA =
  { eqb_ = (fun x y ->
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).equal
      x y); eqbP_ =
    (set_setoidDec_obligation_1 setoidA posetA setoidDecA posetDecA) }

(** val set_posetDec_obligation_1 :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set ->
    'a1 set -> reflect **)

let set_posetDec_obligation_1 setoidA posetA setoidDecA posetDecA x y =
  let _evar_0_ = fun _ -> ReflectT in
  let _evar_0_0 = fun _ -> ReflectF in
  if (coq_SetAVL_FSet
       (order_OrderedType setoidA posetA setoidDecA posetDecA)).subset x y
  then _evar_0_ __
  else _evar_0_0 __

(** val set_posetDec :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set
    posetDec **)

let set_posetDec setoidA posetA setoidDecA posetDecA =
  { leb_ = (fun x y ->
    (coq_SetAVL_FSet (order_OrderedType setoidA posetA setoidDecA posetDecA)).subset
      x y); lebP_ =
    (set_posetDec_obligation_1 setoidA posetA setoidDecA posetDecA) }

(** val set_to_powerset :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set ->
    'a1 powerset **)

let set_to_powerset h h0 h2 h3 s x =
  (set_setlike h h0 h2 h3).smem x s

