open Bool
open Datatypes
open Ssrbool

type 'a setoid =
| Setoid

type 'a poset =
| Poset

type 'a hasBot =
  'a
  (* singleton inductive, whose constructor was HasBot *)

(** val bot_ : 'a1 setoid -> 'a1 poset -> 'a1 hasBot -> 'a1 **)

let bot_ h h0 hasBot0 =
  hasBot0

(** val bot : 'a1 setoid -> 'a1 poset -> 'a1 hasBot -> 'a1 **)

let bot h h0 h1 =
  bot_ h h0 h1

type 'a hasTop =
  'a
  (* singleton inductive, whose constructor was HasTop *)

(** val top_ : 'a1 setoid -> 'a1 poset -> 'a1 hasTop -> 'a1 **)

let top_ h h0 hasTop0 =
  hasTop0

(** val top : 'a1 setoid -> 'a1 poset -> 'a1 hasTop -> 'a1 **)

let top h h0 h1 =
  top_ h h0 h1

type 'a hasJoin =
  'a -> 'a -> 'a
  (* singleton inductive, whose constructor was HasJoin *)

(** val join_ :
    'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 -> 'a1 -> 'a1 **)

let join_ h h0 hasJoin0 =
  hasJoin0

(** val join :
    'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 -> 'a1 -> 'a1 **)

let join h h0 h1 =
  join_ h h0 h1

type 'a setoidDec = { eqb_ : ('a -> 'a -> bool);
                      eqbP_ : ('a -> 'a -> reflect) }

(** val eqb_ : 'a1 setoid -> 'a1 setoidDec -> 'a1 -> 'a1 -> bool **)

let eqb_ _ x = x.eqb_

(** val eqbP_ : 'a1 setoid -> 'a1 setoidDec -> 'a1 -> 'a1 -> reflect **)

let eqbP_ _ x = x.eqbP_

(** val eqb : 'a1 setoid -> 'a1 setoidDec -> 'a1 -> 'a1 -> bool **)

let eqb h h0 =
  h0.eqb_

(** val eqbP : 'a1 setoid -> 'a1 setoidDec -> 'a1 -> 'a1 -> reflect **)

let eqbP h h0 =
  h0.eqbP_

type 'a posetDec = { leb_ : ('a -> 'a -> bool); lebP_ : ('a -> 'a -> reflect) }

(** val leb_ :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
    bool **)

let leb_ _ _ _ x = x.leb_

(** val lebP_ :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
    reflect **)

let lebP_ _ _ _ x = x.lebP_

(** val leb :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
    bool **)

let leb setoidA posetA setoidDecA h =
  h.leb_

(** val lebP :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
    reflect **)

let lebP setoidA posetA setoidDecA h =
  h.lebP_

(** val ltb :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
    bool **)

let ltb setoidA posetA setoidDecA h x y =
  (&&) (leb setoidA posetA setoidDecA h x y)
    (negb (eqb setoidA setoidDecA x y))

(** val bool_setoid : bool setoid **)

let bool_setoid =
  Setoid

(** val bool_poset : bool poset **)

let bool_poset =
  Poset

(** val bool_setoidDec_obligation_1 : bool -> bool -> reflect **)

let bool_setoidDec_obligation_1 x y =
  let _evar_0_ =
    let _evar_0_ = ReflectT in
    let _evar_0_0 = ReflectF in if y then _evar_0_ else _evar_0_0
  in
  let _evar_0_0 =
    let _evar_0_0 = ReflectF in
    let _evar_0_1 = ReflectT in if y then _evar_0_0 else _evar_0_1
  in
  if x then _evar_0_ else _evar_0_0

(** val bool_setoidDec : bool setoidDec **)

let bool_setoidDec =
  { eqb_ = Bool.eqb; eqbP_ = bool_setoidDec_obligation_1 }

(** val bool_posetDec_obligation_1 : bool -> bool -> reflect **)

let bool_posetDec_obligation_1 x y =
  let _evar_0_ =
    let _evar_0_ = ReflectT in
    let _evar_0_0 = ReflectF in if y then _evar_0_ else _evar_0_0
  in
  let _evar_0_0 =
    let _evar_0_0 = ReflectT in
    let _evar_0_1 = ReflectT in if y then _evar_0_0 else _evar_0_1
  in
  if x then _evar_0_ else _evar_0_0

(** val bool_posetDec : bool posetDec **)

let bool_posetDec =
  { leb_ = (fun x y -> implb x y); lebP_ = bool_posetDec_obligation_1 }

type ('key, 'elt, 'm) maplike = { mlookup : ('key -> 'm -> 'elt);
                                  madd : ('key -> 'elt -> 'm -> 'm);
                                  mremove : ('key -> 'm -> 'm) }

(** val mlookup :
    'a1 setoid -> 'a1 setoidDec -> 'a2 setoid -> 'a3 setoid -> 'a2 poset ->
    'a3 poset -> ('a1, 'a2, 'a3) maplike -> 'a1 -> 'a3 -> 'a2 **)

let mlookup _ _ _ _ _ _ x = x.mlookup

(** val madd :
    'a1 setoid -> 'a1 setoidDec -> 'a2 setoid -> 'a3 setoid -> 'a2 poset ->
    'a3 poset -> ('a1, 'a2, 'a3) maplike -> 'a1 -> 'a2 -> 'a3 -> 'a3 **)

let madd _ _ _ _ _ _ x = x.madd

(** val mremove :
    'a1 setoid -> 'a1 setoidDec -> 'a2 setoid -> 'a3 setoid -> 'a2 poset ->
    'a3 poset -> ('a1, 'a2, 'a3) maplike -> 'a1 -> 'a3 -> 'a3 **)

let mremove _ _ _ _ _ _ x = x.mremove

type ('elt, 's) setlike = { sempty : 's; ssingleton : ('elt -> 's);
                            smem : ('elt -> 's -> bool);
                            sadd : ('elt -> 's -> 's);
                            sremove : ('elt -> 's -> 's) }

(** val ssingleton :
    'a1 setoid -> 'a2 setoid -> ('a1, 'a2) setlike -> 'a1 -> 'a2 **)

let ssingleton _ _ x = x.ssingleton

(** val smem :
    'a1 setoid -> 'a2 setoid -> ('a1, 'a2) setlike -> 'a1 -> 'a2 -> bool **)

let smem _ _ x = x.smem

