open Bool
open Datatypes
open Ssrbool

type 'a setoid =
| Setoid

type 'a poset =
| Poset

type 'a hasBot =
  'a
  (* singleton inductive, whose constructor was HasBot *)

val bot_ : 'a1 setoid -> 'a1 poset -> 'a1 hasBot -> 'a1

val bot : 'a1 setoid -> 'a1 poset -> 'a1 hasBot -> 'a1

type 'a hasTop =
  'a
  (* singleton inductive, whose constructor was HasTop *)

val top_ : 'a1 setoid -> 'a1 poset -> 'a1 hasTop -> 'a1

val top : 'a1 setoid -> 'a1 poset -> 'a1 hasTop -> 'a1

type 'a hasJoin =
  'a -> 'a -> 'a
  (* singleton inductive, whose constructor was HasJoin *)

val join_ : 'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 -> 'a1 -> 'a1

val join : 'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 -> 'a1 -> 'a1

type 'a setoidDec = { eqb_ : ('a -> 'a -> bool);
                      eqbP_ : ('a -> 'a -> reflect) }

val eqb_ : 'a1 setoid -> 'a1 setoidDec -> 'a1 -> 'a1 -> bool

val eqbP_ : 'a1 setoid -> 'a1 setoidDec -> 'a1 -> 'a1 -> reflect

val eqb : 'a1 setoid -> 'a1 setoidDec -> 'a1 -> 'a1 -> bool

val eqbP : 'a1 setoid -> 'a1 setoidDec -> 'a1 -> 'a1 -> reflect

type 'a posetDec = { leb_ : ('a -> 'a -> bool); lebP_ : ('a -> 'a -> reflect) }

val leb_ :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
  bool

val lebP_ :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
  reflect

val leb :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
  bool

val lebP :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
  reflect

val ltb :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 -> 'a1 ->
  bool

val bool_setoid : bool setoid

val bool_poset : bool poset

val bool_setoidDec_obligation_1 : bool -> bool -> reflect

val bool_setoidDec : bool setoidDec

val bool_posetDec_obligation_1 : bool -> bool -> reflect

val bool_posetDec : bool posetDec

type ('key, 'elt, 'm) maplike = { mlookup : ('key -> 'm -> 'elt);
                                  madd : ('key -> 'elt -> 'm -> 'm);
                                  mremove : ('key -> 'm -> 'm) }

val mlookup :
  'a1 setoid -> 'a1 setoidDec -> 'a2 setoid -> 'a3 setoid -> 'a2 poset -> 'a3
  poset -> ('a1, 'a2, 'a3) maplike -> 'a1 -> 'a3 -> 'a2

val madd :
  'a1 setoid -> 'a1 setoidDec -> 'a2 setoid -> 'a3 setoid -> 'a2 poset -> 'a3
  poset -> ('a1, 'a2, 'a3) maplike -> 'a1 -> 'a2 -> 'a3 -> 'a3

val mremove :
  'a1 setoid -> 'a1 setoidDec -> 'a2 setoid -> 'a3 setoid -> 'a2 poset -> 'a3
  poset -> ('a1, 'a2, 'a3) maplike -> 'a1 -> 'a3 -> 'a3

type ('elt, 's) setlike = { sempty : 's; ssingleton : ('elt -> 's);
                            smem : ('elt -> 's -> bool);
                            sadd : ('elt -> 's -> 's);
                            sremove : ('elt -> 's -> 's) }

val ssingleton : 'a1 setoid -> 'a2 setoid -> ('a1, 'a2) setlike -> 'a1 -> 'a2

val smem :
  'a1 setoid -> 'a2 setoid -> ('a1, 'a2) setlike -> 'a1 -> 'a2 -> bool

