open BinInt
open DomType
open ZArith_dec
open Ssrbool

(** val coq_Z_setoid : int setoid **)

let coq_Z_setoid =
  Setoid

(** val coq_Z_poset : int poset **)

let coq_Z_poset =
  Poset

(** val coq_Z_setoidDec_obligation_1 : int -> int -> reflect **)

let coq_Z_setoidDec_obligation_1 x y =
  let _evar_0_ =
    let _evar_0_ = ReflectT in
    let _evar_0_0 = ReflectF in if Z.eqb x y then _evar_0_ else _evar_0_0
  in
  equivP (Z.eqb x y) _evar_0_

(** val coq_Z_setoidDec : int setoidDec **)

let coq_Z_setoidDec =
  { eqb_ = Z.eqb; eqbP_ = coq_Z_setoidDec_obligation_1 }

(** val coq_Z_posetDec_obligation_1 : int -> int -> reflect **)

let coq_Z_posetDec_obligation_1 x y =
  let _evar_0_ =
    let _evar_0_ = ReflectT in
    let _evar_0_0 = ReflectF in if Z.leb x y then _evar_0_ else _evar_0_0
  in
  equivP (Z.leb x y) _evar_0_

(** val coq_Z_posetDec : int posetDec **)

let coq_Z_posetDec =
  { leb_ = Z.leb; lebP_ = coq_Z_posetDec_obligation_1 }

(** val l_z_u_dec : int -> int -> bool **)

let l_z_u_dec l u =
  let s = coq_Z_le_dec l 0 in if s then coq_Z_le_dec 0 u else false

(** val coq_Cdiv : int -> int -> int **)

let coq_Cdiv z1 z2 =
  if (||)
       ((&&)
         (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0 z1)
         (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0 z2))
       ((&&)
         (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec z1 0)
         (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec z2 0))
  then Z.div (Z.abs z1) (Z.abs z2)
  else Z.opp (Z.div (Z.abs z1) (Z.abs z2))

