open Datatypes
open List0
open OrderedType
open OrderedTypeEx

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

module MapList = 
 struct 
  type ('key, 'elt) dict = ('key * 'elt) list
  
  (** val empty : 'a1 coq_OrderedType -> ('a1, 'a2) dict **)
  
  let empty comparedec =
    []
  
  (** val is_empty : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> bool **)
  
  let is_empty comparedec = function
  | [] -> true
  | x :: x0 -> false
  
  (** val mem : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> bool **)
  
  let rec mem comparedec k = function
  | [] -> false
  | p :: l ->
    let (k', e) = p in
    (match compare comparedec k k' with
     | Eq -> true
     | Lt -> false
     | Gt -> mem comparedec k l)
  
  type ('key, 'elt) coq_R_mem =
  | R_mem_0 of ('key, 'elt) dict
  | R_mem_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_mem_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_mem_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list * 
     bool * ('key, 'elt) coq_R_mem
  
  (** val coq_R_mem_rect :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      bool -> ('a1, 'a2) coq_R_mem -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> bool
      -> ('a1, 'a2) coq_R_mem -> 'a3 **)
  
  let rec coq_R_mem_rect comparedec k f f0 f1 f2 s b = function
  | R_mem_0 s0 -> f s0 __
  | R_mem_1 (s0, k', _x, l) -> f0 s0 k' _x l __ __
  | R_mem_2 (s0, k', _x, l) -> f1 s0 k' _x l __ __
  | R_mem_3 (s0, k', _x, l, res, r0) ->
    f2 s0 k' _x l __ __ res r0
      (coq_R_mem_rect comparedec k f f0 f1 f2 l res r0)
  
  (** val coq_R_mem_rec :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      bool -> ('a1, 'a2) coq_R_mem -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> bool
      -> ('a1, 'a2) coq_R_mem -> 'a3 **)
  
  let rec coq_R_mem_rec comparedec k f f0 f1 f2 s b = function
  | R_mem_0 s0 -> f s0 __
  | R_mem_1 (s0, k', _x, l) -> f0 s0 k' _x l __ __
  | R_mem_2 (s0, k', _x, l) -> f1 s0 k' _x l __ __
  | R_mem_3 (s0, k', _x, l, res, r0) ->
    f2 s0 k' _x l __ __ res r0
      (coq_R_mem_rec comparedec k f f0 f1 f2 l res r0)
  
  (** val mem_rect :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let rec mem_rect comparedec k f f0 f1 f2 s =
    let f3 = f s in
    let f4 = f0 s in
    let f5 = f1 s in
    let f6 = f2 s in
    (match s with
     | [] -> f3 __
     | p :: l ->
       let (k0, e) = p in
       let f7 = f6 k0 e l __ in
       let f8 = fun _ ->
         let hrec = mem_rect comparedec k f f0 f1 f2 l in f7 __ hrec
       in
       let f9 = f5 k0 e l __ in
       let f10 = f4 k0 e l __ in
       (match compare comparedec k k0 with
        | Eq -> f9 __
        | Lt -> f10 __
        | Gt -> f8 __))
  
  (** val mem_rec :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let mem_rec comparedec k f f0 f1 f2 s =
    mem_rect comparedec k f f0 f1 f2 s
  
  (** val coq_R_mem_correct :
      'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> bool -> ('a1, 'a2)
      coq_R_mem **)
  
  let coq_R_mem_correct comparedec k s res =
    let princ = fun x -> mem_rect comparedec x in
    Obj.magic princ k (fun y _ z _ -> R_mem_0 y) (fun y y0 y1 y2 _ _ z _ ->
      R_mem_1 (y, y0, y1, y2)) (fun y y0 y1 y2 _ _ z _ -> R_mem_2 (y, y0, y1,
      y2)) (fun y y0 y1 y2 _ _ y5 z _ -> R_mem_3 (y, y0, y1, y2,
      (mem comparedec k y2), (y5 (mem comparedec k y2) __))) s res __
  
  (** val find :
      'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> 'a2 option **)
  
  let rec find comparedec k = function
  | [] -> None
  | p :: s' ->
    let (k', x) = p in
    (match compare comparedec k k' with
     | Eq -> Some x
     | Lt -> None
     | Gt -> find comparedec k s')
  
  type ('key, 'elt) coq_R_find =
  | R_find_0 of ('key, 'elt) dict
  | R_find_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_find_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_find_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * 'elt option * ('key, 'elt) coq_R_find
  
  (** val coq_R_find_rect :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a2 option -> ('a1, 'a2) coq_R_find -> 'a3 -> 'a3) -> ('a1, 'a2) dict
      -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3 **)
  
  let rec coq_R_find_rect comparedec k f f0 f1 f2 s o = function
  | R_find_0 s0 -> f s0 __
  | R_find_1 (s0, k', x, s') -> f0 s0 k' x s' __ __
  | R_find_2 (s0, k', x, s') -> f1 s0 k' x s' __ __
  | R_find_3 (s0, k', x, s', res, r0) ->
    f2 s0 k' x s' __ __ res r0
      (coq_R_find_rect comparedec k f f0 f1 f2 s' res r0)
  
  (** val coq_R_find_rec :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a2 option -> ('a1, 'a2) coq_R_find -> 'a3 -> 'a3) -> ('a1, 'a2) dict
      -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3 **)
  
  let rec coq_R_find_rec comparedec k f f0 f1 f2 s o = function
  | R_find_0 s0 -> f s0 __
  | R_find_1 (s0, k', x, s') -> f0 s0 k' x s' __ __
  | R_find_2 (s0, k', x, s') -> f1 s0 k' x s' __ __
  | R_find_3 (s0, k', x, s', res, r0) ->
    f2 s0 k' x s' __ __ res r0
      (coq_R_find_rec comparedec k f f0 f1 f2 s' res r0)
  
  (** val find_rect :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let rec find_rect comparedec k f f0 f1 f2 s =
    let f3 = f s in
    let f4 = f0 s in
    let f5 = f1 s in
    let f6 = f2 s in
    (match s with
     | [] -> f3 __
     | p :: l ->
       let (k0, e) = p in
       let f7 = f6 k0 e l __ in
       let f8 = fun _ ->
         let hrec = find_rect comparedec k f f0 f1 f2 l in f7 __ hrec
       in
       let f9 = f5 k0 e l __ in
       let f10 = f4 k0 e l __ in
       (match compare comparedec k k0 with
        | Eq -> f9 __
        | Lt -> f10 __
        | Gt -> f8 __))
  
  (** val find_rec :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let find_rec comparedec k f f0 f1 f2 s =
    find_rect comparedec k f f0 f1 f2 s
  
  (** val coq_R_find_correct :
      'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> 'a2 option -> ('a1,
      'a2) coq_R_find **)
  
  let coq_R_find_correct comparedec k s res =
    let princ = fun x -> find_rect comparedec x in
    Obj.magic princ k (fun y _ z _ -> R_find_0 y) (fun y y0 y1 y2 _ _ z _ ->
      R_find_1 (y, y0, y1, y2)) (fun y y0 y1 y2 _ _ z _ -> R_find_2 (y, y0,
      y1, y2)) (fun y y0 y1 y2 _ _ y5 z _ -> R_find_3 (y, y0, y1, y2,
      (find comparedec k y2), (y5 (find comparedec k y2) __))) s res __
  
  (** val add :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) dict -> ('a1, 'a2) dict **)
  
  let rec add comparedec k x s = match s with
  | [] -> (k, x) :: []
  | p :: l ->
    let (k', y) = p in
    (match compare comparedec k k' with
     | Eq -> (k, x) :: l
     | Lt -> (k, x) :: s
     | Gt -> (k', y) :: (add comparedec k x l))
  
  type ('key, 'elt) coq_R_add =
  | R_add_0 of ('key, 'elt) dict
  | R_add_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_add_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_add_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * ('key, 'elt) dict * ('key, 'elt) coq_R_add
  
  (** val coq_R_add_rect :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __
      -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) -> ('a1, 'a2)
      dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 **)
  
  let rec coq_R_add_rect comparedec k x f f0 f1 f2 s t = function
  | R_add_0 s0 -> f s0 __
  | R_add_1 (s0, k', y, l) -> f0 s0 k' y l __ __
  | R_add_2 (s0, k', y, l) -> f1 s0 k' y l __ __
  | R_add_3 (s0, k', y, l, res, r0) ->
    f2 s0 k' y l __ __ res r0
      (coq_R_add_rect comparedec k x f f0 f1 f2 l res r0)
  
  (** val coq_R_add_rec :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __
      -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) -> ('a1, 'a2)
      dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 **)
  
  let rec coq_R_add_rec comparedec k x f f0 f1 f2 s t = function
  | R_add_0 s0 -> f s0 __
  | R_add_1 (s0, k', y, l) -> f0 s0 k' y l __ __
  | R_add_2 (s0, k', y, l) -> f1 s0 k' y l __ __
  | R_add_3 (s0, k', y, l, res, r0) ->
    f2 s0 k' y l __ __ res r0
      (coq_R_add_rec comparedec k x f f0 f1 f2 l res r0)
  
  (** val add_rect :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __
      -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let rec add_rect comparedec k x f f0 f1 f2 s =
    let f3 = f s in
    let f4 = f0 s in
    let f5 = f1 s in
    let f6 = f2 s in
    (match s with
     | [] -> f3 __
     | p :: l ->
       let (k0, e) = p in
       let f7 = f6 k0 e l __ in
       let f8 = fun _ ->
         let hrec = add_rect comparedec k x f f0 f1 f2 l in f7 __ hrec
       in
       let f9 = f5 k0 e l __ in
       let f10 = f4 k0 e l __ in
       (match compare comparedec k k0 with
        | Eq -> f9 __
        | Lt -> f10 __
        | Gt -> f8 __))
  
  (** val add_rec :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __
      -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let add_rec comparedec k x f f0 f1 f2 s =
    add_rect comparedec k x f f0 f1 f2 s
  
  (** val coq_R_add_correct :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) dict -> ('a1, 'a2) dict
      -> ('a1, 'a2) coq_R_add **)
  
  let coq_R_add_correct comparedec k x s res =
    add_rect comparedec k x (fun y _ z _ -> R_add_0 y)
      (fun y y0 y1 y2 _ _ z _ -> R_add_1 (y, y0, y1, y2))
      (fun y y0 y1 y2 _ _ z _ -> R_add_2 (y, y0, y1, y2))
      (fun y y0 y1 y2 _ _ y5 z _ -> R_add_3 (y, y0, y1, y2,
      (add comparedec k x y2), (y5 (add comparedec k x y2) __))) s res __
  
  (** val remove :
      'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> ('a1, 'a2) dict **)
  
  let rec remove comparedec k s = match s with
  | [] -> []
  | p :: l ->
    let (k', x) = p in
    (match compare comparedec k k' with
     | Eq -> l
     | Lt -> s
     | Gt -> (k', x) :: (remove comparedec k l))
  
  type ('key, 'elt) coq_R_remove =
  | R_remove_0 of ('key, 'elt) dict
  | R_remove_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_remove_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_remove_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * ('key, 'elt) dict * ('key, 'elt) coq_R_remove
  
  (** val coq_R_remove_rect :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3 -> 'a3) -> ('a1, 'a2)
      dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3 **)
  
  let rec coq_R_remove_rect comparedec k f f0 f1 f2 s t = function
  | R_remove_0 s0 -> f s0 __
  | R_remove_1 (s0, k', x, l) -> f0 s0 k' x l __ __
  | R_remove_2 (s0, k', x, l) -> f1 s0 k' x l __ __
  | R_remove_3 (s0, k', x, l, res, r0) ->
    f2 s0 k' x l __ __ res r0
      (coq_R_remove_rect comparedec k f f0 f1 f2 l res r0)
  
  (** val coq_R_remove_rec :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3 -> 'a3) -> ('a1, 'a2)
      dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3 **)
  
  let rec coq_R_remove_rec comparedec k f f0 f1 f2 s t = function
  | R_remove_0 s0 -> f s0 __
  | R_remove_1 (s0, k', x, l) -> f0 s0 k' x l __ __
  | R_remove_2 (s0, k', x, l) -> f1 s0 k' x l __ __
  | R_remove_3 (s0, k', x, l, res, r0) ->
    f2 s0 k' x l __ __ res r0
      (coq_R_remove_rec comparedec k f f0 f1 f2 l res r0)
  
  (** val remove_rect :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let rec remove_rect comparedec k f f0 f1 f2 s =
    let f3 = f s in
    let f4 = f0 s in
    let f5 = f1 s in
    let f6 = f2 s in
    (match s with
     | [] -> f3 __
     | p :: l ->
       let (k0, e) = p in
       let f7 = f6 k0 e l __ in
       let f8 = fun _ ->
         let hrec = remove_rect comparedec k f f0 f1 f2 l in f7 __ hrec
       in
       let f9 = f5 k0 e l __ in
       let f10 = f4 k0 e l __ in
       (match compare comparedec k k0 with
        | Eq -> f9 __
        | Lt -> f10 __
        | Gt -> f8 __))
  
  (** val remove_rec :
      'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
      'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3)
      -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let remove_rec comparedec k f f0 f1 f2 s =
    remove_rect comparedec k f f0 f1 f2 s
  
  (** val coq_R_remove_correct :
      'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> ('a1, 'a2) dict ->
      ('a1, 'a2) coq_R_remove **)
  
  let coq_R_remove_correct comparedec k s res =
    let princ = fun x -> remove_rect comparedec x in
    Obj.magic princ k (fun y _ z _ -> R_remove_0 y)
      (fun y y0 y1 y2 _ _ z _ -> R_remove_1 (y, y0, y1, y2))
      (fun y y0 y1 y2 _ _ z _ -> R_remove_2 (y, y0, y1, y2))
      (fun y y0 y1 y2 _ _ y5 z _ -> R_remove_3 (y, y0, y1, y2,
      (remove comparedec k y2), (y5 (remove comparedec k y2) __))) s res __
  
  (** val insert :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) dict ->
      ('a1, 'a2) dict **)
  
  let rec insert comparedec k d f s = match s with
  | [] -> (k, d) :: []
  | p :: l ->
    let (k', y) = p in
    (match compare comparedec k k' with
     | Eq -> (k, (f y)) :: l
     | Lt -> (k, d) :: s
     | Gt -> (k', y) :: (insert comparedec k d f l))
  
  type ('key, 'elt) coq_R_insert =
  | R_insert_0 of ('key, 'elt) dict
  | R_insert_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_insert_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_insert_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * ('key, 'elt) dict * ('key, 'elt) coq_R_insert
  
  (** val coq_R_insert_rect :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
      -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
      __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
      -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
      list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert -> 'a3
      -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2)
      coq_R_insert -> 'a3 **)
  
  let rec coq_R_insert_rect comparedec k d f f0 f1 f2 f3 s t = function
  | R_insert_0 s0 -> f0 s0 __
  | R_insert_1 (s0, k', y, l) -> f1 s0 k' y l __ __
  | R_insert_2 (s0, k', y, l) -> f2 s0 k' y l __ __
  | R_insert_3 (s0, k', y, l, res, r0) ->
    f3 s0 k' y l __ __ res r0
      (coq_R_insert_rect comparedec k d f f0 f1 f2 f3 l res r0)
  
  (** val coq_R_insert_rec :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
      -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
      __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
      -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
      list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert -> 'a3
      -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2)
      coq_R_insert -> 'a3 **)
  
  let rec coq_R_insert_rec comparedec k d f f0 f1 f2 f3 s t = function
  | R_insert_0 s0 -> f0 s0 __
  | R_insert_1 (s0, k', y, l) -> f1 s0 k' y l __ __
  | R_insert_2 (s0, k', y, l) -> f2 s0 k' y l __ __
  | R_insert_3 (s0, k', y, l, res, r0) ->
    f3 s0 k' y l __ __ res r0
      (coq_R_insert_rec comparedec k d f f0 f1 f2 f3 l res r0)
  
  (** val insert_rect :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
      -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
      __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
      -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
      list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let rec insert_rect comparedec k d f f0 f1 f2 f3 s =
    let f4 = f0 s in
    let f5 = f1 s in
    let f6 = f2 s in
    let f7 = f3 s in
    (match s with
     | [] -> f4 __
     | p :: l ->
       let (k0, e) = p in
       let f8 = f7 k0 e l __ in
       let f9 = fun _ ->
         let hrec = insert_rect comparedec k d f f0 f1 f2 f3 l in f8 __ hrec
       in
       let f10 = f6 k0 e l __ in
       let f11 = f5 k0 e l __ in
       (match compare comparedec k k0 with
        | Eq -> f10 __
        | Lt -> f11 __
        | Gt -> f9 __))
  
  (** val insert_rec :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
      -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
      __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
      -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
      list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let insert_rec comparedec k d f f0 f1 f2 f3 s =
    insert_rect comparedec k d f f0 f1 f2 f3 s
  
  (** val coq_R_insert_correct :
      'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) dict ->
      ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert **)
  
  let coq_R_insert_correct comparedec k d f s res =
    insert_rect comparedec k d f (fun y _ z _ -> R_insert_0 y)
      (fun y y0 y1 y2 _ _ z _ -> R_insert_1 (y, y0, y1, y2))
      (fun y y0 y1 y2 _ _ z _ -> R_insert_2 (y, y0, y1, y2))
      (fun y y0 y1 y2 _ _ y5 z _ -> R_insert_3 (y, y0, y1, y2,
      (insert comparedec k d f y2), (y5 (insert comparedec k d f y2) __))) s
      res __
  
  (** val adjust :
      'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) dict -> ('a1,
      'a2) dict **)
  
  let rec adjust comparedec k f s = match s with
  | [] -> []
  | p :: l ->
    let (k', y) = p in
    (match compare comparedec k k' with
     | Eq -> (k, (f y)) :: l
     | Lt -> s
     | Gt -> (k', y) :: (adjust comparedec k f l))
  
  type ('key, 'elt) coq_R_adjust =
  | R_adjust_0 of ('key, 'elt) dict
  | R_adjust_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_adjust_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_adjust_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * ('key, 'elt) dict * ('key, 'elt) coq_R_adjust
  
  (** val coq_R_adjust_rect :
      'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __ ->
      'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __
      -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
      __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
      -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) ->
      ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3 **)
  
  let rec coq_R_adjust_rect comparedec k f f0 f1 f2 f3 s t = function
  | R_adjust_0 s0 -> f0 s0 __
  | R_adjust_1 (s0, k', y, l) -> f1 s0 k' y l __ __
  | R_adjust_2 (s0, k', y, l) -> f2 s0 k' y l __ __
  | R_adjust_3 (s0, k', y, l, res, r0) ->
    f3 s0 k' y l __ __ res r0
      (coq_R_adjust_rect comparedec k f f0 f1 f2 f3 l res r0)
  
  (** val coq_R_adjust_rec :
      'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __ ->
      'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __
      -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
      __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
      -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) ->
      ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3 **)
  
  let rec coq_R_adjust_rec comparedec k f f0 f1 f2 f3 s t = function
  | R_adjust_0 s0 -> f0 s0 __
  | R_adjust_1 (s0, k', y, l) -> f1 s0 k' y l __ __
  | R_adjust_2 (s0, k', y, l) -> f2 s0 k' y l __ __
  | R_adjust_3 (s0, k', y, l, res, r0) ->
    f3 s0 k' y l __ __ res r0
      (coq_R_adjust_rec comparedec k f f0 f1 f2 f3 l res r0)
  
  (** val adjust_rect :
      'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __ ->
      'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __
      -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
      __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
      -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let rec adjust_rect comparedec k f f0 f1 f2 f3 s =
    let f4 = f0 s in
    let f5 = f1 s in
    let f6 = f2 s in
    let f7 = f3 s in
    (match s with
     | [] -> f4 __
     | p :: l ->
       let (k0, e) = p in
       let f8 = f7 k0 e l __ in
       let f9 = fun _ ->
         let hrec = adjust_rect comparedec k f f0 f1 f2 f3 l in f8 __ hrec
       in
       let f10 = f6 k0 e l __ in
       let f11 = f5 k0 e l __ in
       (match compare comparedec k k0 with
        | Eq -> f10 __
        | Lt -> f11 __
        | Gt -> f9 __))
  
  (** val adjust_rec :
      'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __ ->
      'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __
      -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
      __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
      -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)
  
  let adjust_rec comparedec k f f0 f1 f2 f3 s =
    adjust_rect comparedec k f f0 f1 f2 f3 s
  
  (** val coq_R_adjust_correct :
      'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) dict -> ('a1,
      'a2) dict -> ('a1, 'a2) coq_R_adjust **)
  
  let coq_R_adjust_correct comparedec k f s res =
    adjust_rect comparedec k f (fun y _ z _ -> R_adjust_0 y)
      (fun y y0 y1 y2 _ _ z _ -> R_adjust_1 (y, y0, y1, y2))
      (fun y y0 y1 y2 _ _ z _ -> R_adjust_2 (y, y0, y1, y2))
      (fun y y0 y1 y2 _ _ y5 z _ -> R_adjust_3 (y, y0, y1, y2,
      (adjust comparedec k f y2), (y5 (adjust comparedec k f y2) __))) s res
      __
  
  (** val elements :
      'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1, 'a2) dict **)
  
  let elements comparedec m =
    m
  
  (** val cardinal : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> int **)
  
  let cardinal comparedec m =
    length m
  
  (** val choose :
      'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1 * 'a2) option **)
  
  let choose comparedec = function
  | [] -> None
  | p :: l -> Some p
  
  (** val fold :
      'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) dict ->
      'a3 -> 'a3 **)
  
  let rec fold comparedec f m acc =
    match m with
    | [] -> acc
    | p :: m' -> let (k, e) = p in fold comparedec f m' (f k e acc)
  
  type ('key, 'elt, 'a) coq_R_fold =
  | R_fold_0 of ('key, 'elt) dict * 'a
  | R_fold_1 of ('key, 'elt) dict * 'a * 'key * 'elt * ('key * 'elt) list
     * 'a * ('key, 'elt, 'a) coq_R_fold
  
  (** val coq_R_fold_rect :
      'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
      -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4 ->
      'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold ->
      'a4 **)
  
  let rec coq_R_fold_rect comparedec f f0 f1 m acc y = function
  | R_fold_0 (m0, acc0) -> f0 m0 acc0 __
  | R_fold_1 (m0, acc0, k, e, m', res, r0) ->
    f1 m0 acc0 k e m' __ res r0
      (coq_R_fold_rect comparedec f f0 f1 m' (f k e acc0) res r0)
  
  (** val coq_R_fold_rec :
      'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
      -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4 ->
      'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold ->
      'a4 **)
  
  let rec coq_R_fold_rec comparedec f f0 f1 m acc y = function
  | R_fold_0 (m0, acc0) -> f0 m0 acc0 __
  | R_fold_1 (m0, acc0, k, e, m', res, r0) ->
    f1 m0 acc0 k e m' __ res r0
      (coq_R_fold_rec comparedec f f0 f1 m' (f k e acc0) res r0)
  
  (** val fold_rect :
      'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
      -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> 'a4 -> 'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a4 **)
  
  let rec fold_rect comparedec f f0 f1 m acc =
    let f2 = f0 m acc in
    let f3 = f1 m acc in
    (match m with
     | [] -> f2 __
     | p :: l ->
       let (k, e) = p in
       let f4 = f3 k e l __ in
       let hrec = fold_rect comparedec f f0 f1 l (f k e acc) in f4 hrec)
  
  (** val fold_rec :
      'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
      -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> 'a4 -> 'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a4 **)
  
  let fold_rec comparedec f f0 f1 m acc =
    fold_rect comparedec f f0 f1 m acc
  
  (** val coq_R_fold_correct :
      'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) dict ->
      'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold **)
  
  let coq_R_fold_correct comparedec f m acc res =
    fold_rect comparedec f (fun y y0 _ z _ -> R_fold_0 (y, y0))
      (fun y y0 y1 y2 y3 _ y5 z _ -> R_fold_1 (y, y0, y1, y2, y3,
      (fold comparedec f y3 (f y1 y2 y0)),
      (y5 (fold comparedec f y3 (f y1 y2 y0)) __))) m acc res __
  
  (** val equal :
      'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) dict -> ('a1,
      'a2) dict -> bool **)
  
  let rec equal comparedec cmp m m' =
    match m with
    | [] ->
      (match m' with
       | [] -> true
       | p :: l -> false)
    | p :: l ->
      let (x, e) = p in
      (match m' with
       | [] -> false
       | p0 :: l' ->
         let (x', e') = p0 in
         (match compare comparedec x x' with
          | Eq -> if cmp e e' then equal comparedec cmp l l' else false
          | _ -> false))
  
  type ('key, 'elt) coq_R_equal =
  | R_equal_0 of ('key, 'elt) dict * ('key, 'elt) dict
  | R_equal_1 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
     * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list * bool
     * ('key, 'elt) coq_R_equal
  | R_equal_2 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
     * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list
  | R_equal_3 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
     * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list * comparison
  | R_equal_4 of ('key, 'elt) dict * ('key, 'elt) dict * ('key, 'elt) dict
     * ('key, 'elt) dict
  
  (** val coq_R_equal_rect :
      'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
      ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
      dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> __ -> __ -> bool -> ('a1, 'a2) coq_R_equal ->
      'a3 -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
      comparison -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict
      -> ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict -> __ -> __ -> 'a3) ->
      ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool -> ('a1, 'a2) coq_R_equal ->
      'a3 **)
  
  let rec coq_R_equal_rect comparedec cmp f f0 f1 f2 f3 m m' b = function
  | R_equal_0 (m0, m'0) -> f m0 m'0 __ __
  | R_equal_1 (m0, m'0, x, e, l, x', e', l', res, r0) ->
    f0 m0 m'0 x e l __ x' e' l' __ __ __ res r0
      (coq_R_equal_rect comparedec cmp f f0 f1 f2 f3 l l' res r0)
  | R_equal_2 (m0, m'0, x, e, l, x', e', l') ->
    f1 m0 m'0 x e l __ x' e' l' __ __ __
  | R_equal_3 (m0, m'0, x, e, l, x', e', l', _x) ->
    f2 m0 m'0 x e l __ x' e' l' __ _x __ __
  | R_equal_4 (m0, m'0, _x, _x0) -> f3 m0 m'0 _x __ _x0 __ __
  
  (** val coq_R_equal_rec :
      'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
      ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
      dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> __ -> __ -> bool -> ('a1, 'a2) coq_R_equal ->
      'a3 -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
      __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
      comparison -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict
      -> ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict -> __ -> __ -> 'a3) ->
      ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool -> ('a1, 'a2) coq_R_equal ->
      'a3 **)
  
  let rec coq_R_equal_rec comparedec cmp f f0 f1 f2 f3 m m' b = function
  | R_equal_0 (m0, m'0) -> f m0 m'0 __ __
  | R_equal_1 (m0, m'0, x, e, l, x', e', l', res, r0) ->
    f0 m0 m'0 x e l __ x' e' l' __ __ __ res r0
      (coq_R_equal_rec comparedec cmp f f0 f1 f2 f3 l l' res r0)
  | R_equal_2 (m0, m'0, x, e, l, x', e', l') ->
    f1 m0 m'0 x e l __ x' e' l' __ __ __
  | R_equal_3 (m0, m'0, x, e, l, x', e', l', _x) ->
    f2 m0 m'0 x e l __ x' e' l' __ _x __ __
  | R_equal_4 (m0, m'0, _x, _x0) -> f3 m0 m'0 _x __ _x0 __ __
  
  (** val equal_rect :
      'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
      ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
      dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3 -> 'a3) -> (('a1, 'a2) dict
      -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
      'a2 -> ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) dict
      -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
      'a2 -> ('a1 * 'a2) list -> __ -> comparison -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> ('a1,
      'a2) dict -> __ -> __ -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict ->
      'a3 **)
  
  let rec equal_rect comparedec cmp f f0 f1 f2 f3 m m' =
    let f4 = f m m' in
    let f5 = f0 m m' in
    let f6 = f1 m m' in
    let f7 = f2 m m' in
    let f8 = f3 m m' in
    let f9 = f8 m __ in
    let f10 = f9 m' __ in
    (match m with
     | [] ->
       let f11 = f4 __ in
       (match m' with
        | [] -> f11 __
        | p :: l -> f10 __)
     | p :: l ->
       let (k, e) = p in
       let f11 = f7 k e l __ in
       let f12 = f6 k e l __ in
       let f13 = f5 k e l __ in
       (match m' with
        | [] -> f10 __
        | p0 :: l0 ->
          let (k0, e0) = p0 in
          let f14 = f11 k0 e0 l0 __ in
          let f15 = let _x = compare comparedec k k0 in f14 _x __ in
          let f16 = f12 k0 e0 l0 __ in
          let f17 = f13 k0 e0 l0 __ in
          let f18 = fun _ _ ->
            let hrec = equal_rect comparedec cmp f f0 f1 f2 f3 l l0 in
            f17 __ __ hrec
          in
          (match compare comparedec k k0 with
           | Eq ->
             let f19 = f18 __ in
             let f20 = f16 __ in if cmp e e0 then f19 __ else f20 __
           | _ -> f15 __)))
  
  (** val equal_rec :
      'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
      ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
      dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
      ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3 -> 'a3) -> (('a1, 'a2) dict
      -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
      'a2 -> ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) dict
      -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
      'a2 -> ('a1 * 'a2) list -> __ -> comparison -> __ -> __ -> 'a3) ->
      (('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> ('a1,
      'a2) dict -> __ -> __ -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict ->
      'a3 **)
  
  let equal_rec comparedec cmp f f0 f1 f2 f3 m m' =
    equal_rect comparedec cmp f f0 f1 f2 f3 m m'
  
  (** val coq_R_equal_correct :
      'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) dict -> ('a1,
      'a2) dict -> bool -> ('a1, 'a2) coq_R_equal **)
  
  let coq_R_equal_correct comparedec cmp m m' res =
    equal_rect comparedec cmp (fun y y0 _ _ z _ -> R_equal_0 (y, y0))
      (fun y y0 y1 y2 y3 _ y5 y6 y7 _ _ _ y11 z _ -> R_equal_1 (y, y0, y1,
      y2, y3, y5, y6, y7, (equal comparedec cmp y3 y7),
      (y11 (equal comparedec cmp y3 y7) __)))
      (fun y y0 y1 y2 y3 _ y5 y6 y7 _ _ _ z _ -> R_equal_2 (y, y0, y1, y2,
      y3, y5, y6, y7)) (fun y y0 y1 y2 y3 _ y5 y6 y7 _ y9 _ _ z _ ->
      R_equal_3 (y, y0, y1, y2, y3, y5, y6, y7, y9))
      (fun y y0 y1 _ y3 _ _ z _ -> R_equal_4 (y, y0, y1, y3)) m m' res __
  
  (** val map :
      'a1 coq_OrderedType -> ('a2 -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a3)
      dict **)
  
  let rec map comparedec f = function
  | [] -> []
  | p :: m' -> let (k, e) = p in (k, (f e)) :: (map comparedec f m')
  
  (** val mapi :
      'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) dict -> ('a1,
      'a3) dict **)
  
  let rec mapi comparedec f = function
  | [] -> []
  | p :: m' -> let (k, e) = p in (k, (f k e)) :: (mapi comparedec f m')
  
  (** val option_cons :
      'a1 -> 'a2 option -> ('a1 * 'a2) list -> ('a1 * 'a2) list **)
  
  let option_cons k o l =
    match o with
    | Some e -> (k, e) :: l
    | None -> l
  
  (** val map2_l :
      'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
      ('a1, 'a2) dict -> ('a1, 'a4) dict **)
  
  let rec map2_l comparedec f = function
  | [] -> []
  | p :: l ->
    let (k, e) = p in option_cons k (f (Some e) None) (map2_l comparedec f l)
  
  (** val map2_r :
      'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
      ('a1, 'a3) dict -> ('a1, 'a4) dict **)
  
  let rec map2_r comparedec f = function
  | [] -> []
  | p :: l' ->
    let (k, e') = p in
    option_cons k (f None (Some e')) (map2_r comparedec f l')
  
  (** val map2 :
      'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
      ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1, 'a4) dict **)
  
  let rec map2 comparedec f m x =
    match m with
    | [] -> map2_r comparedec f x
    | p :: l ->
      let (k, e) = p in
      let rec map2_aux m' = match m' with
      | [] -> map2_l comparedec f m
      | p0 :: l' ->
        let (k', e') = p0 in
        (match compare comparedec k k' with
         | Eq ->
           option_cons k (f (Some e) (Some e')) (map2 comparedec f l l')
         | Lt -> option_cons k (f (Some e) None) (map2 comparedec f l m')
         | Gt -> option_cons k' (f None (Some e')) (map2_aux l'))
      in map2_aux x
  
  (** val map_OrderedType :
      'a1 coq_OrderedType -> ('a1, 'a2) dict coq_OrderedType **)
  
  let map_OrderedType h =
    list_OrderedType (asym_prod_OrderedType h)
  
  module K = KeyOrderedType
  
  (** val combine :
      'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1, 'a2
      option * 'a3 option) dict **)
  
  let rec combine key_OT m = match m with
  | [] -> map key_OT (fun e' -> (None, (Some e')))
  | p :: l ->
    let (k, e) = p in
    let rec combine_aux m' = match m' with
    | [] -> map key_OT (fun e0 -> ((Some e0), None)) m
    | p0 :: l' ->
      let (k', e') = p0 in
      (match compare key_OT k k' with
       | Eq -> (k, ((Some e), (Some e'))) :: (combine key_OT l l')
       | Lt -> (k, ((Some e), None)) :: (combine key_OT l m')
       | Gt -> (k', (None, (Some e'))) :: (combine_aux l'))
    in combine_aux
  
  (** val fold_right_pair :
      ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3 **)
  
  let fold_right_pair f l i =
    fold_right (fun p -> f (fst p) (snd p)) i l
  
  (** val map2_alt :
      'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
      ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1 * 'a4) list **)
  
  let map2_alt key_OT f m m' =
    let m0 = combine key_OT m m' in
    let m1 = map key_OT (fun p -> f (fst p) (snd p)) m0 in
    fold_right_pair option_cons m1 []
  
  (** val at_least_one :
      'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option **)
  
  let at_least_one o o' =
    match o with
    | Some e -> Some (o, o')
    | None ->
      (match o' with
       | Some e -> Some (o, o')
       | None -> None)
  
  (** val at_least_one_then_f :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2 option ->
      'a3 option **)
  
  let at_least_one_then_f f o o' =
    match o with
    | Some e -> f o o'
    | None ->
      (match o' with
       | Some e -> f o o'
       | None -> None)
 end

