open BinInt
open Datatypes
open OrderedType
open Peano
open ZArith_dec

type __ = Obj.t

module SetAVL : 
 sig 
  type 'elt tree =
  | Leaf
  | Node of 'elt tree * 'elt * 'elt tree * int
  
  val tree_rect :
    'a1 coq_OrderedType -> 'a2 -> ('a1 tree -> 'a2 -> 'a1 -> 'a1 tree -> 'a2
    -> int -> 'a2) -> 'a1 tree -> 'a2
  
  val tree_rec :
    'a1 coq_OrderedType -> 'a2 -> ('a1 tree -> 'a2 -> 'a1 -> 'a1 tree -> 'a2
    -> int -> 'a2) -> 'a1 tree -> 'a2
  
  val height : 'a1 coq_OrderedType -> 'a1 tree -> int
  
  val cardinal : 'a1 coq_OrderedType -> 'a1 tree -> int
  
  val empty : 'a1 coq_OrderedType -> 'a1 tree
  
  val is_empty : 'a1 coq_OrderedType -> 'a1 tree -> bool
  
  val mem : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree -> bool
  
  val singleton : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree
  
  val create : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val assert_false :
    'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val bal : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val add : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val join : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val remove_min :
    'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree * 'a1
  
  val merge : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val remove : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val min_elt : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 option
  
  val max_elt : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 option
  
  val choose : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 option
  
  val concat : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  type 'elt triple = { t_left : 'elt tree; t_in : bool; t_right : 'elt tree }
  
  val triple_rect :
    'a1 coq_OrderedType -> ('a1 tree -> bool -> 'a1 tree -> 'a2) -> 'a1
    triple -> 'a2
  
  val triple_rec :
    'a1 coq_OrderedType -> ('a1 tree -> bool -> 'a1 tree -> 'a2) -> 'a1
    triple -> 'a2
  
  val t_left : 'a1 coq_OrderedType -> 'a1 triple -> 'a1 tree
  
  val t_in : 'a1 coq_OrderedType -> 'a1 triple -> bool
  
  val t_right : 'a1 coq_OrderedType -> 'a1 triple -> 'a1 tree
  
  val split : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree -> 'a1 triple
  
  val inter : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val diff : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val union : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val elements_aux : 'a1 coq_OrderedType -> 'a1 list -> 'a1 tree -> 'a1 list
  
  val elements : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 list
  
  val filter_acc :
    'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val filter : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> 'a1 tree
  
  val partition_acc :
    'a1 coq_OrderedType -> ('a1 -> bool) -> ('a1 tree * 'a1 tree) -> 'a1 tree
    -> 'a1 tree * 'a1 tree
  
  val partition :
    'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> 'a1 tree * 'a1 tree
  
  val for_all : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> bool
  
  val exists_ : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> bool
  
  val map_monotonic :
    'a1 coq_OrderedType -> 'a2 coq_OrderedType -> ('a1 -> 'a2) -> 'a1 tree ->
    'a2 tree
  
  val fold :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2
  
  val subsetl :
    'a1 coq_OrderedType -> ('a1 tree -> bool) -> 'a1 -> 'a1 tree -> bool
  
  val subsetr :
    'a1 coq_OrderedType -> ('a1 tree -> bool) -> 'a1 -> 'a1 tree -> bool
  
  val subset : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> bool
  
  type 'elt enumeration =
  | End
  | More of 'elt * 'elt tree * 'elt enumeration
  
  val enumeration_rect :
    'a1 coq_OrderedType -> 'a2 -> ('a1 -> 'a1 tree -> 'a1 enumeration -> 'a2
    -> 'a2) -> 'a1 enumeration -> 'a2
  
  val enumeration_rec :
    'a1 coq_OrderedType -> 'a2 -> ('a1 -> 'a1 tree -> 'a1 enumeration -> 'a2
    -> 'a2) -> 'a1 enumeration -> 'a2
  
  val cons :
    'a1 coq_OrderedType -> 'a1 tree -> 'a1 enumeration -> 'a1 enumeration
  
  val compare_more :
    'a1 coq_OrderedType -> 'a1 -> ('a1 enumeration -> comparison) -> 'a1
    enumeration -> comparison
  
  val compare_cont :
    'a1 coq_OrderedType -> 'a1 tree -> ('a1 enumeration -> comparison) -> 'a1
    enumeration -> comparison
  
  val compare_end : 'a1 coq_OrderedType -> 'a1 enumeration -> comparison
  
  val compare : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> comparison
  
  val equal : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> bool
  
  type 'elt coq_R_mem =
  | R_mem_0 of 'elt tree
  | R_mem_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_mem_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * bool
     * 'elt coq_R_mem
  | R_mem_3 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * bool
     * 'elt coq_R_mem
  
  val coq_R_mem_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> bool -> 'a1 coq_R_mem ->
    'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ ->
    __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
    coq_R_mem -> 'a2
  
  val coq_R_mem_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> bool -> 'a1 coq_R_mem ->
    'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ ->
    __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
    coq_R_mem -> 'a2
  
  type 'elt coq_R_bal =
  | R_bal_0 of 'elt tree * 'elt * 'elt tree
  | R_bal_1 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int
  | R_bal_2 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int
  | R_bal_3 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int * 'elt tree * 'elt * 'elt tree * int
  | R_bal_4 of 'elt tree * 'elt * 'elt tree
  | R_bal_5 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int
  | R_bal_6 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int
  | R_bal_7 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int * 'elt tree * 'elt * 'elt tree * int
  | R_bal_8 of 'elt tree * 'elt * 'elt tree
  
  val coq_R_bal_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ ->
    'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree
    -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __ -> __
    -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int
    -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ ->
    __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
    'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree ->
    int -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __
    -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __
    -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a2) -> ('a1 tree -> 'a1
    -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> 'a1 -> 'a1
    tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2
  
  val coq_R_bal_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ ->
    'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree
    -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __ -> __
    -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int
    -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ ->
    __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
    'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree ->
    int -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __
    -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __
    -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a2) -> ('a1 tree -> 'a1
    -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> 'a1 -> 'a1
    tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2
  
  type 'elt coq_R_add =
  | R_add_0 of 'elt tree
  | R_add_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_add_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt coq_R_add
  | R_add_3 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt coq_R_add
  
  val coq_R_add_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 tree -> 'a1 coq_R_add
    -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> __ -> 'a1 tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree
    -> 'a1 coq_R_add -> 'a2
  
  val coq_R_add_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 tree -> 'a1 coq_R_add
    -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> __ -> 'a1 tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree
    -> 'a1 coq_R_add -> 'a2
  
  type 'elt coq_R_remove_min =
  | R_remove_min_0 of 'elt tree * 'elt * 'elt tree
  | R_remove_min_1 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt
     * 'elt tree * int * ('elt tree * 'elt) * 'elt coq_R_remove_min
     * 'elt tree * 'elt
  
  val coq_R_remove_min_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1
    tree -> 'a1 -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ ->
    ('a1 tree * 'a1) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1 tree -> 'a1 -> __
    -> 'a2) -> 'a1 tree -> 'a1 -> 'a1 tree -> ('a1 tree * 'a1) -> 'a1
    coq_R_remove_min -> 'a2
  
  val coq_R_remove_min_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1
    tree -> 'a1 -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ ->
    ('a1 tree * 'a1) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1 tree -> 'a1 -> __
    -> 'a2) -> 'a1 tree -> 'a1 -> 'a1 tree -> ('a1 tree * 'a1) -> 'a1
    coq_R_remove_min -> 'a2
  
  type 'elt coq_R_merge =
  | R_merge_0 of 'elt tree * 'elt tree
  | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * 'elt
  
  val coq_R_merge_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> __ -> 'a2) ->
    'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2
  
  val coq_R_merge_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> __ -> 'a2) ->
    'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2
  
  type 'elt coq_R_remove =
  | R_remove_0 of 'elt tree
  | R_remove_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_remove_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt coq_R_remove
  | R_remove_3 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt coq_R_remove
  
  val coq_R_remove_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 tree -> 'a1
    coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree
    -> int -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1
    tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2
  
  val coq_R_remove_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 tree -> 'a1
    coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree
    -> int -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1
    tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2
  
  type 'elt coq_R_min_elt =
  | R_min_elt_0 of 'elt tree
  | R_min_elt_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_min_elt_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt * 'elt tree * int * 'elt option * 'elt coq_R_min_elt
  
  val coq_R_min_elt_rect :
    'a1 coq_OrderedType -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
    -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
    'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> 'a1 option -> 'a1 coq_R_min_elt -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
    option -> 'a1 coq_R_min_elt -> 'a2
  
  val coq_R_min_elt_rec :
    'a1 coq_OrderedType -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
    -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
    'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> 'a1 option -> 'a1 coq_R_min_elt -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
    option -> 'a1 coq_R_min_elt -> 'a2
  
  type 'elt coq_R_max_elt =
  | R_max_elt_0 of 'elt tree
  | R_max_elt_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_max_elt_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt * 'elt tree * int * 'elt option * 'elt coq_R_max_elt
  
  val coq_R_max_elt_rect :
    'a1 coq_OrderedType -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
    -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
    'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> 'a1 option -> 'a1 coq_R_max_elt -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
    option -> 'a1 coq_R_max_elt -> 'a2
  
  val coq_R_max_elt_rec :
    'a1 coq_OrderedType -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
    -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
    'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> 'a1 option -> 'a1 coq_R_max_elt -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
    option -> 'a1 coq_R_max_elt -> 'a2
  
  type 'elt coq_R_concat =
  | R_concat_0 of 'elt tree * 'elt tree
  | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * 'elt
  
  val coq_R_concat_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> __ -> 'a2) ->
    'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2
  
  val coq_R_concat_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> __ -> 'a2) ->
    'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2
  
  type 'elt coq_R_split =
  | R_split_0 of 'elt tree
  | R_split_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_split_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt triple
     * 'elt coq_R_split * 'elt tree * bool * 'elt tree
  | R_split_3 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt triple
     * 'elt coq_R_split * 'elt tree * bool * 'elt tree
  
  val coq_R_split_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 triple -> 'a1
    coq_R_split -> 'a2 -> 'a1 tree -> bool -> 'a1 tree -> __ -> 'a2) -> ('a1
    tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 triple ->
    'a1 coq_R_split -> 'a2 -> 'a1 tree -> bool -> 'a1 tree -> __ -> 'a2) ->
    'a1 tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2
  
  val coq_R_split_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 triple -> 'a1
    coq_R_split -> 'a2 -> 'a1 tree -> bool -> 'a1 tree -> __ -> 'a2) -> ('a1
    tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 triple ->
    'a1 coq_R_split -> 'a2 -> 'a1 tree -> bool -> 'a1 tree -> __ -> 'a2) ->
    'a1 tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2
  
  type 'elt coq_R_inter =
  | R_inter_0 of 'elt tree * 'elt tree
  | R_inter_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_inter_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_inter * 'elt tree * 'elt coq_R_inter
  | R_inter_3 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_inter * 'elt tree * 'elt coq_R_inter
  
  val coq_R_inter_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> __ -> 'a1 tree -> 'a1 coq_R_inter -> 'a2 -> 'a1 tree -> 'a1
    coq_R_inter -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> bool -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 coq_R_inter ->
    'a2 -> 'a1 tree -> 'a1 coq_R_inter -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree
    -> 'a1 tree -> 'a1 coq_R_inter -> 'a2
  
  val coq_R_inter_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> __ -> 'a1 tree -> 'a1 coq_R_inter -> 'a2 -> 'a1 tree -> 'a1
    coq_R_inter -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> bool -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 coq_R_inter ->
    'a2 -> 'a1 tree -> 'a1 coq_R_inter -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree
    -> 'a1 tree -> 'a1 coq_R_inter -> 'a2
  
  type 'elt coq_R_diff =
  | R_diff_0 of 'elt tree * 'elt tree
  | R_diff_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_diff_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_diff * 'elt tree * 'elt coq_R_diff
  | R_diff_3 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_diff * 'elt tree * 'elt coq_R_diff
  
  val coq_R_diff_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> __ -> 'a1 tree -> 'a1 coq_R_diff -> 'a2 -> 'a1 tree -> 'a1
    coq_R_diff -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> bool -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 coq_R_diff -> 'a2
    -> 'a1 tree -> 'a1 coq_R_diff -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree ->
    'a1 tree -> 'a1 coq_R_diff -> 'a2
  
  val coq_R_diff_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> __ -> 'a1 tree -> 'a1 coq_R_diff -> 'a2 -> 'a1 tree -> 'a1
    coq_R_diff -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> bool -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 coq_R_diff -> 'a2
    -> 'a1 tree -> 'a1 coq_R_diff -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree ->
    'a1 tree -> 'a1 coq_R_diff -> 'a2
  
  type 'elt coq_R_union =
  | R_union_0 of 'elt tree * 'elt tree
  | R_union_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_union_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_union * 'elt tree * 'elt coq_R_union
  
  val coq_R_union_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> 'a1 tree -> 'a1 coq_R_union -> 'a2 -> 'a1 tree -> 'a1 coq_R_union
    -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_union ->
    'a2
  
  val coq_R_union_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> 'a1 tree -> 'a1 coq_R_union -> 'a2 -> 'a1 tree -> 'a1 coq_R_union
    -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_union ->
    'a2
  
  val fold' :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2
  
  val flatten_e : 'a1 coq_OrderedType -> 'a1 enumeration -> 'a1 list
 end

module S : 
 sig 
  type 'elt tree = 'elt SetAVL.tree =
  | Leaf
  | Node of 'elt tree * 'elt * 'elt tree * int
  
  val tree_rect :
    'a1 coq_OrderedType -> 'a2 -> ('a1 tree -> 'a2 -> 'a1 -> 'a1 tree -> 'a2
    -> int -> 'a2) -> 'a1 tree -> 'a2
  
  val tree_rec :
    'a1 coq_OrderedType -> 'a2 -> ('a1 tree -> 'a2 -> 'a1 -> 'a1 tree -> 'a2
    -> int -> 'a2) -> 'a1 tree -> 'a2
  
  val height : 'a1 coq_OrderedType -> 'a1 tree -> int
  
  val cardinal : 'a1 coq_OrderedType -> 'a1 tree -> int
  
  val empty : 'a1 coq_OrderedType -> 'a1 tree
  
  val is_empty : 'a1 coq_OrderedType -> 'a1 tree -> bool
  
  val mem : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree -> bool
  
  val singleton : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree
  
  val create : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val assert_false :
    'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val bal : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val add : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val join : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val remove_min :
    'a1 coq_OrderedType -> 'a1 tree -> 'a1 -> 'a1 tree -> 'a1 tree * 'a1
  
  val merge : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val remove : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree -> 'a1 tree
  
  val min_elt : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 option
  
  val max_elt : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 option
  
  val choose : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 option
  
  val concat : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  type 'elt triple = { t_left : 'elt tree; t_in : bool; t_right : 'elt tree }
  
  val triple_rect :
    'a1 coq_OrderedType -> ('a1 tree -> bool -> 'a1 tree -> 'a2) -> 'a1
    triple -> 'a2
  
  val triple_rec :
    'a1 coq_OrderedType -> ('a1 tree -> bool -> 'a1 tree -> 'a2) -> 'a1
    triple -> 'a2
  
  val t_left : 'a1 coq_OrderedType -> 'a1 triple -> 'a1 tree
  
  val t_in : 'a1 coq_OrderedType -> 'a1 triple -> bool
  
  val t_right : 'a1 coq_OrderedType -> 'a1 triple -> 'a1 tree
  
  val split : 'a1 coq_OrderedType -> 'a1 -> 'a1 tree -> 'a1 triple
  
  val inter : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val diff : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val union : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val elements_aux : 'a1 coq_OrderedType -> 'a1 list -> 'a1 tree -> 'a1 list
  
  val elements : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 list
  
  val filter_acc :
    'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> 'a1 tree -> 'a1 tree
  
  val filter : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> 'a1 tree
  
  val partition_acc :
    'a1 coq_OrderedType -> ('a1 -> bool) -> ('a1 tree * 'a1 tree) -> 'a1 tree
    -> 'a1 tree * 'a1 tree
  
  val partition :
    'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> 'a1 tree * 'a1 tree
  
  val for_all : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> bool
  
  val exists_ : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 tree -> bool
  
  val map_monotonic :
    'a1 coq_OrderedType -> 'a2 coq_OrderedType -> ('a1 -> 'a2) -> 'a1 tree ->
    'a2 tree
  
  val fold :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2
  
  val subsetl :
    'a1 coq_OrderedType -> ('a1 tree -> bool) -> 'a1 -> 'a1 tree -> bool
  
  val subsetr :
    'a1 coq_OrderedType -> ('a1 tree -> bool) -> 'a1 -> 'a1 tree -> bool
  
  val subset : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> bool
  
  type 'elt enumeration =
  | End
  | More of 'elt * 'elt tree * 'elt enumeration
  
  val enumeration_rect :
    'a1 coq_OrderedType -> 'a2 -> ('a1 -> 'a1 tree -> 'a1 enumeration -> 'a2
    -> 'a2) -> 'a1 enumeration -> 'a2
  
  val enumeration_rec :
    'a1 coq_OrderedType -> 'a2 -> ('a1 -> 'a1 tree -> 'a1 enumeration -> 'a2
    -> 'a2) -> 'a1 enumeration -> 'a2
  
  val cons :
    'a1 coq_OrderedType -> 'a1 tree -> 'a1 enumeration -> 'a1 enumeration
  
  val compare_more :
    'a1 coq_OrderedType -> 'a1 -> ('a1 enumeration -> comparison) -> 'a1
    enumeration -> comparison
  
  val compare_cont :
    'a1 coq_OrderedType -> 'a1 tree -> ('a1 enumeration -> comparison) -> 'a1
    enumeration -> comparison
  
  val compare_end : 'a1 coq_OrderedType -> 'a1 enumeration -> comparison
  
  val compare : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> comparison
  
  val equal : 'a1 coq_OrderedType -> 'a1 tree -> 'a1 tree -> bool
  
  type 'elt coq_R_mem =
  | R_mem_0 of 'elt tree
  | R_mem_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_mem_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * bool
     * 'elt coq_R_mem
  | R_mem_3 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * bool
     * 'elt coq_R_mem
  
  val coq_R_mem_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> bool -> 'a1 coq_R_mem ->
    'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ ->
    __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
    coq_R_mem -> 'a2
  
  val coq_R_mem_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> bool -> 'a1 coq_R_mem ->
    'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ ->
    __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
    coq_R_mem -> 'a2
  
  type 'elt coq_R_bal =
  | R_bal_0 of 'elt tree * 'elt * 'elt tree
  | R_bal_1 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int
  | R_bal_2 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int
  | R_bal_3 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int * 'elt tree * 'elt * 'elt tree * int
  | R_bal_4 of 'elt tree * 'elt * 'elt tree
  | R_bal_5 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int
  | R_bal_6 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int
  | R_bal_7 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt * 'elt tree
     * int * 'elt tree * 'elt * 'elt tree * int
  | R_bal_8 of 'elt tree * 'elt * 'elt tree
  
  val coq_R_bal_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ ->
    'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree
    -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __ -> __
    -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int
    -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ ->
    __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
    'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree ->
    int -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __
    -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __
    -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a2) -> ('a1 tree -> 'a1
    -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> 'a1 -> 'a1
    tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2
  
  val coq_R_bal_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ ->
    'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree
    -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __ -> __
    -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int
    -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ ->
    __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
    'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree ->
    int -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 -> 'a1 tree -> __
    -> __ -> __ -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> __
    -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a2) -> ('a1 tree -> 'a1
    -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> 'a1 -> 'a1
    tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2
  
  type 'elt coq_R_add =
  | R_add_0 of 'elt tree
  | R_add_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_add_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt coq_R_add
  | R_add_3 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt coq_R_add
  
  val coq_R_add_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 tree -> 'a1 coq_R_add
    -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> __ -> 'a1 tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree
    -> 'a1 coq_R_add -> 'a2
  
  val coq_R_add_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 tree -> 'a1 coq_R_add
    -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> __ -> 'a1 tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree
    -> 'a1 coq_R_add -> 'a2
  
  type 'elt coq_R_remove_min =
  | R_remove_min_0 of 'elt tree * 'elt * 'elt tree
  | R_remove_min_1 of 'elt tree * 'elt * 'elt tree * 'elt tree * 'elt
     * 'elt tree * int * ('elt tree * 'elt) * 'elt coq_R_remove_min
     * 'elt tree * 'elt
  
  val coq_R_remove_min_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1
    tree -> 'a1 -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ ->
    ('a1 tree * 'a1) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1 tree -> 'a1 -> __
    -> 'a2) -> 'a1 tree -> 'a1 -> 'a1 tree -> ('a1 tree * 'a1) -> 'a1
    coq_R_remove_min -> 'a2
  
  val coq_R_remove_min_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1
    tree -> 'a1 -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ ->
    ('a1 tree * 'a1) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1 tree -> 'a1 -> __
    -> 'a2) -> 'a1 tree -> 'a1 -> 'a1 tree -> ('a1 tree * 'a1) -> 'a1
    coq_R_remove_min -> 'a2
  
  type 'elt coq_R_merge =
  | R_merge_0 of 'elt tree * 'elt tree
  | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * 'elt
  
  val coq_R_merge_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> __ -> 'a2) ->
    'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2
  
  val coq_R_merge_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> __ -> 'a2) ->
    'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2
  
  type 'elt coq_R_remove =
  | R_remove_0 of 'elt tree
  | R_remove_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_remove_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt coq_R_remove
  | R_remove_3 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt coq_R_remove
  
  val coq_R_remove_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 tree -> 'a1
    coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree
    -> int -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1
    tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2
  
  val coq_R_remove_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 tree -> 'a1
    coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree
    -> int -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1
    tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2
  
  type 'elt coq_R_min_elt =
  | R_min_elt_0 of 'elt tree
  | R_min_elt_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_min_elt_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt * 'elt tree * int * 'elt option * 'elt coq_R_min_elt
  
  val coq_R_min_elt_rect :
    'a1 coq_OrderedType -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
    -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
    'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> 'a1 option -> 'a1 coq_R_min_elt -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
    option -> 'a1 coq_R_min_elt -> 'a2
  
  val coq_R_min_elt_rec :
    'a1 coq_OrderedType -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
    -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
    'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> 'a1 option -> 'a1 coq_R_min_elt -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
    option -> 'a1 coq_R_min_elt -> 'a2
  
  type 'elt coq_R_max_elt =
  | R_max_elt_0 of 'elt tree
  | R_max_elt_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_max_elt_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt tree
     * 'elt * 'elt tree * int * 'elt option * 'elt coq_R_max_elt
  
  val coq_R_max_elt_rect :
    'a1 coq_OrderedType -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
    -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
    'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> 'a1 option -> 'a1 coq_R_max_elt -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
    option -> 'a1 coq_R_max_elt -> 'a2
  
  val coq_R_max_elt_rec :
    'a1 coq_OrderedType -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree
    -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
    'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __
    -> 'a1 option -> 'a1 coq_R_max_elt -> 'a2 -> 'a2) -> 'a1 tree -> 'a1
    option -> 'a1 coq_R_max_elt -> 'a2
  
  type 'elt coq_R_concat =
  | R_concat_0 of 'elt tree * 'elt tree
  | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * 'elt
  
  val coq_R_concat_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> __ -> 'a2) ->
    'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2
  
  val coq_R_concat_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> __ -> 'a2) ->
    'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2
  
  type 'elt coq_R_split =
  | R_split_0 of 'elt tree
  | R_split_1 of 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_split_2 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt triple
     * 'elt coq_R_split * 'elt tree * bool * 'elt tree
  | R_split_3 of 'elt tree * 'elt tree * 'elt * 'elt tree * int * 'elt triple
     * 'elt coq_R_split * 'elt tree * bool * 'elt tree
  
  val coq_R_split_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 triple -> 'a1
    coq_R_split -> 'a2 -> 'a1 tree -> bool -> 'a1 tree -> __ -> 'a2) -> ('a1
    tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 triple ->
    'a1 coq_R_split -> 'a2 -> 'a1 tree -> bool -> 'a1 tree -> __ -> 'a2) ->
    'a1 tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2
  
  val coq_R_split_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 triple -> 'a1
    coq_R_split -> 'a2 -> 'a1 tree -> bool -> 'a1 tree -> __ -> 'a2) -> ('a1
    tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a1 triple ->
    'a1 coq_R_split -> 'a2 -> 'a1 tree -> bool -> 'a1 tree -> __ -> 'a2) ->
    'a1 tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2
  
  type 'elt coq_R_inter =
  | R_inter_0 of 'elt tree * 'elt tree
  | R_inter_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_inter_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_inter * 'elt tree * 'elt coq_R_inter
  | R_inter_3 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_inter * 'elt tree * 'elt coq_R_inter
  
  val coq_R_inter_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> __ -> 'a1 tree -> 'a1 coq_R_inter -> 'a2 -> 'a1 tree -> 'a1
    coq_R_inter -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> bool -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 coq_R_inter ->
    'a2 -> 'a1 tree -> 'a1 coq_R_inter -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree
    -> 'a1 tree -> 'a1 coq_R_inter -> 'a2
  
  val coq_R_inter_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> __ -> 'a1 tree -> 'a1 coq_R_inter -> 'a2 -> 'a1 tree -> 'a1
    coq_R_inter -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> bool -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 coq_R_inter ->
    'a2 -> 'a1 tree -> 'a1 coq_R_inter -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree
    -> 'a1 tree -> 'a1 coq_R_inter -> 'a2
  
  type 'elt coq_R_diff =
  | R_diff_0 of 'elt tree * 'elt tree
  | R_diff_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_diff_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_diff * 'elt tree * 'elt coq_R_diff
  | R_diff_3 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_diff * 'elt tree * 'elt coq_R_diff
  
  val coq_R_diff_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> __ -> 'a1 tree -> 'a1 coq_R_diff -> 'a2 -> 'a1 tree -> 'a1
    coq_R_diff -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> bool -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 coq_R_diff -> 'a2
    -> 'a1 tree -> 'a1 coq_R_diff -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree ->
    'a1 tree -> 'a1 coq_R_diff -> 'a2
  
  val coq_R_diff_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> __ -> 'a1 tree -> 'a1 coq_R_diff -> 'a2 -> 'a1 tree -> 'a1
    coq_R_diff -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 ->
    'a1 tree -> int -> __ -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> bool -> 'a1 tree -> __ -> __ -> 'a1 tree -> 'a1 coq_R_diff -> 'a2
    -> 'a1 tree -> 'a1 coq_R_diff -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree ->
    'a1 tree -> 'a1 coq_R_diff -> 'a2
  
  type 'elt coq_R_union =
  | R_union_0 of 'elt tree * 'elt tree
  | R_union_1 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * int
  | R_union_2 of 'elt tree * 'elt tree * 'elt tree * 'elt * 'elt tree * 
     int * 'elt tree * 'elt * 'elt tree * int * 'elt tree * bool * 'elt tree
     * 'elt tree * 'elt coq_R_union * 'elt tree * 'elt coq_R_union
  
  val coq_R_union_rect :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> 'a1 tree -> 'a1 coq_R_union -> 'a2 -> 'a1 tree -> 'a1 coq_R_union
    -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_union ->
    'a2
  
  val coq_R_union_rec :
    'a1 coq_OrderedType -> ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree
    -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> __ -> 'a2) ->
    ('a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1
    tree -> 'a1 -> 'a1 tree -> int -> __ -> 'a1 tree -> bool -> 'a1 tree ->
    __ -> 'a1 tree -> 'a1 coq_R_union -> 'a2 -> 'a1 tree -> 'a1 coq_R_union
    -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_union ->
    'a2
  
  val fold' :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2
  
  val flatten_e : 'a1 coq_OrderedType -> 'a1 enumeration -> 'a1 list
 end

type 'elt set =
  'elt S.tree
  (* singleton inductive, whose constructor was Bst *)

val this : 'a1 coq_OrderedType -> 'a1 set -> 'a1 S.tree

val mem : 'a1 coq_OrderedType -> 'a1 -> 'a1 set -> bool

val empty : 'a1 coq_OrderedType -> 'a1 set

val is_empty : 'a1 coq_OrderedType -> 'a1 set -> bool

val singleton : 'a1 coq_OrderedType -> 'a1 -> 'a1 set

val add : 'a1 coq_OrderedType -> 'a1 -> 'a1 set -> 'a1 set

val remove : 'a1 coq_OrderedType -> 'a1 -> 'a1 set -> 'a1 set

val inter : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> 'a1 set

val union : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> 'a1 set

val diff : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> 'a1 set

val elements : 'a1 coq_OrderedType -> 'a1 set -> 'a1 list

val min_elt : 'a1 coq_OrderedType -> 'a1 set -> 'a1 option

val max_elt : 'a1 coq_OrderedType -> 'a1 set -> 'a1 option

val choose : 'a1 coq_OrderedType -> 'a1 set -> 'a1 option

val fold :
  'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a2) -> 'a1 set -> 'a2 -> 'a2

val cardinal : 'a1 coq_OrderedType -> 'a1 set -> int

val filter : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 set -> 'a1 set

val for_all : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 set -> bool

val exists_ : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 set -> bool

val partition :
  'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 set -> 'a1 set * 'a1 set

val equal : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> bool

val subset : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> bool

val set_compare : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> comparison

val set_OrderedType : 'a1 coq_OrderedType -> 'a1 set coq_SpecificOrderedType

