open Datatypes
open List0
open OrderedType
open OrderedTypeEx

module SetList : 
 sig 
  type 'a set = 'a list
  
  val empty : 'a1 coq_OrderedType -> 'a1 set
  
  val is_empty : 'a1 coq_OrderedType -> 'a1 set -> bool
  
  val mem : 'a1 coq_OrderedType -> 'a1 -> 'a1 set -> bool
  
  val add : 'a1 coq_OrderedType -> 'a1 -> 'a1 set -> 'a1 set
  
  val singleton : 'a1 coq_OrderedType -> 'a1 -> 'a1 set
  
  val remove : 'a1 coq_OrderedType -> 'a1 -> 'a1 set -> 'a1 set
  
  val union : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> 'a1 set
  
  val inter : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> 'a1 set
  
  val diff : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> 'a1 set
  
  val equal : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> bool
  
  val subset : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> bool
  
  val fold :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a2) -> 'a1 set -> 'a2 -> 'a2
  
  val map_monotonic :
    'a1 coq_OrderedType -> 'a2 coq_OrderedType -> ('a1 -> 'a2) -> 'a1 set ->
    'a2 set
  
  val filter : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 set -> 'a1 set
  
  val for_all : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 set -> bool
  
  val exists_ : 'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 set -> bool
  
  val partition :
    'a1 coq_OrderedType -> ('a1 -> bool) -> 'a1 set -> 'a1 set * 'a1 set
  
  val cardinal : 'a1 coq_OrderedType -> 'a1 set -> int
  
  val elements : 'a1 coq_OrderedType -> 'a1 set -> 'a1 list
  
  val min_elt : 'a1 coq_OrderedType -> 'a1 set -> 'a1 option
  
  val max_elt : 'a1 coq_OrderedType -> 'a1 set -> 'a1 option
  
  val choose : 'a1 coq_OrderedType -> 'a1 set -> 'a1 option
  
  val map :
    'a1 coq_OrderedType -> 'a2 coq_OrderedType -> ('a1 -> 'a2) -> 'a1 set ->
    'a2 set
  
  val set_compare : 'a1 coq_OrderedType -> 'a1 set -> 'a1 set -> comparison
  
  val set_OrderedType : 'a1 coq_OrderedType -> 'a1 set coq_OrderedType
 end

