Require Import ssreflect.
Require Import ssrfun.
Require Import ssrbool.

Require Import Utf8.
Require Import Setoid.
Require Import Morphisms.

Require Import LibTactics.
Require Import DomType.
Require Import DomBasic.

Require Import Syntax.

Require Import DomAbsValue.
Require Import DomAcc.
Require Import DomAbsMem.
Require Import DomPidxSen.
Require Import DomPidxInsen.

Require Import SemAbsBlock.
Require Import SemAccSen.
Require Import SemAccInsen.

Require Import SemSen.
Require Import SemSenLocal.
Require Import SemInsenLocal.

Require Import CorAbs.
Require Import CorCon.
Require Import TrsLocal.
Require Import CorLocal.
Require Import TrsSen.
Require Import CorAcc.
Require Import CorSen.

Require Import Main.

Set Implicit Arguments.

Theorem correct_postfix (prog:progT) (acc:accT) (state:stateT) (Hvalidate : validate_postfix prog acc state) :
  let state_sen_local := TrsSen.tstate prog state in
  let state_sen := TrsLocal.tstate prog acc state_sen_local in
  forall step state_con (Hsem : SemCon.sem prog step state_con),
    state_con \abs state_sen.
Proof.
  move/andP: Hvalidate => [Hacc Hpostfix].
  move=> state_sen_local state_sen step state_con Hsem_con.
  exploit CorAcc.tacc_correct; [by eauto|move=> Hacc'].
  move: (Hacc')=> [Hcf Hcs _ _].
  eapply CorCon.correct; eauto.
  apply: CorLocal.tstate_correct; first done.
  exact: CorSen.tstate_correct.
Qed.
